(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('classnames'), require('react'), require('fontfaceobserver'), require('@lls/bard'), require('react-dom')) :
  typeof define === 'function' && define.amd ? define(['exports', 'classnames', 'react', 'fontfaceobserver', '@lls/bard', 'react-dom'], factory) :
  (global = global || self, factory(global.Phonics = {}, global.classNames, global.React, global.FontFaceObserver, global.Bard, global.ReactDOM));
}(this, function (exports, classnames, React, FontFaceObserver, bard, ReactDOM) { 'use strict';

  classnames = classnames && classnames.hasOwnProperty('default') ? classnames['default'] : classnames;
  var React__default = 'default' in React ? React['default'] : React;
  FontFaceObserver = FontFaceObserver && FontFaceObserver.hasOwnProperty('default') ? FontFaceObserver['default'] : FontFaceObserver;
  bard = bard && bard.hasOwnProperty('default') ? bard['default'] : bard;
  ReactDOM = ReactDOM && ReactDOM.hasOwnProperty('default') ? ReactDOM['default'] : ReactDOM;

  function _typeof(obj) {
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function (obj) {
        return typeof obj;
      };
    } else {
      _typeof = function (obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }

    return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};
      var ownKeys = Object.keys(source);

      if (typeof Object.getOwnPropertySymbols === 'function') {
        ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
          return Object.getOwnPropertyDescriptor(source, sym).enumerable;
        }));
      }

      ownKeys.forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    }

    return target;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }

  function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};

    var target = _objectWithoutPropertiesLoose(source, excluded);

    var key, i;

    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }

    return target;
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    }

    return _assertThisInitialized(self);
  }

  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
  }

  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }

  function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
  }

  // tslint:disable-next-line
  var PHONE_WIDTH_LIST = [375, 750, 1125]; // tslint:disable-next-line

  var PAD_WIDTH_LIST = [1024, 2048, 3072];
  var PHONE_RATIO = 37.5;
  var PAD_RATIO = 102.4;
  var LONG_TOUCH_DURATION = 700;
  var MAX_MOVE = 5;

  function getDPR() {
    var dpr = Math.floor(window.devicePixelRatio) || 1;
    if (dpr > 3) dpr = 3;
    if (dpr < 1) dpr = 1;
    return dpr;
  }

  var Imager =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(Imager, _React$Component);

    function Imager() {
      var _this;

      _classCallCheck(this, Imager);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(Imager).apply(this, arguments));
      _this.dpr = getDPR();
      _this.container = null;
      _this.touchTimer = null;
      _this.touchX = 0;
      _this.touchY = 0;

      _this.onTouchStart = function (e) {
        var _e$touches$ = e.touches[0],
            pageX = _e$touches$.pageX,
            pageY = _e$touches$.pageY;
        _this.touchX = pageX;
        _this.touchY = pageY;
        _this.touchTimer = Date.now();
      };

      _this.onTouchEnd = function (e) {
        var touchDuration = Date.now() - _this.touchTimer;

        var _e$changedTouches$ = e.changedTouches[0],
            pageX = _e$changedTouches$.pageX,
            pageY = _e$changedTouches$.pageY;
        var onLongTouch = _this.props.onLongTouch;

        var _assertThisInitialize = _assertThisInitialized(_this),
            touchX = _assertThisInitialize.touchX,
            touchY = _assertThisInitialize.touchY;

        var isMove = pageX - touchX > MAX_MOVE || touchX - pageX > MAX_MOVE || pageY - touchY > MAX_MOVE || touchY - pageY > MAX_MOVE;

        if (touchDuration > LONG_TOUCH_DURATION && onLongTouch && !isMove) {
          onLongTouch();
        }
      };

      return _this;
    }

    _createClass(Imager, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        this.initImage();
      }
    }, {
      key: "initImage",
      value: function initImage() {
        var _this2 = this;

        var _this$props = this.props,
            imgList = _this$props.imgList,
            onSuccess = _this$props.onSuccess,
            onFailure = _this$props.onFailure;
        var sequence = Promise.resolve();
        imgList.forEach(function (listItem, index) {
          sequence = sequence.then(function () {
            return _this2.createImage(listItem, index);
          });
        });
        sequence.then(onSuccess, onFailure);
      }
    }, {
      key: "createImage",
      value: function createImage(listItem, index) {
        var dpr = this.dpr,
            props = this.props,
            container = this.container;
        var widthList = props.widthList,
            onClick = props.onClick,
            useDivInner = props.useDivInner,
            isPad = props.isPad;
        var height = listItem.height,
            divInner = listItem.divInner;
        var isDivInner = typeof divInner === 'undefined' ? useDivInner : divInner;
        return new Promise(function (resolve, reject) {
          var box = document.createElement('div');
          box.className = 'imager-container';
          if (height) box.style.height = height;
          if (container) container.appendChild(box);
          var nodeType = isDivInner ? 'div' : 'img';
          var imgEl = document.createElement(nodeType);
          imgEl.className = 'imager-inner';

          if (onClick) {
            imgEl.addEventListener('click', function (event) {
              onClick(event, listItem, index);
            });
          }

          var list = widthList && widthList.length ? widthList : isPad ? PAD_WIDTH_LIST : PHONE_WIDTH_LIST;
          var resource = new Image();
          var miniImg = listItem[list[0]];
          var suitableImg = listItem[list[dpr - 1]];

          resource.onload = function () {
            box.style.backgroundImage = "url(".concat(miniImg, ")");
            box.style.backgroundSize = "100% 100%";

            if (isDivInner) {
              imgEl.style.backgroundImage = "url(".concat(suitableImg, ")");
            } else {
              var el = imgEl;
              el.src = suitableImg;
              el.style.height = height;
            }

            box.appendChild(imgEl);
            resolve();
          };

          resource.onerror = function (err) {
            reject(err);
          };

          resource.src = miniImg;
        });
      }
    }, {
      key: "render",
      value: function render() {
        var _this3 = this;

        var _this$props2 = this.props,
            className = _this$props2.className,
            isPad = _this$props2.isPad;
        return React.createElement("div", {
          onTouchStart: this.onTouchStart,
          onTouchEnd: this.onTouchEnd,
          onTouchCancel: this.onTouchEnd,
          ref: function ref(el) {
            return _this3.container = el;
          },
          className: classnames('ph-imager', className, {
            'is-pad': isPad
          })
        });
      }
    }]);

    return Imager;
  }(React.Component);
  Imager.defaultProps = {
    className: '',
    onSuccess: function onSuccess() {},
    onFailure: function onFailure() {}
  };

  var AVATAR_MAP = {
    male: 'https://cdn.llscdn.com/sprout/sprout-hybrid/avatar/imgBoy@3x.png',
    female: 'https://cdn.llscdn.com/sprout/sprout-hybrid/avatar/imgGirl@3x.png'
  };
  var DEFAULT_AVATAR = AVATAR_MAP.male;

  (function (genderList) {
    genderList["male"] = "male";
    genderList["female"] = "female";
  })(exports.genderList || (exports.genderList = {}));

  Avatar.AVATAR_MAP = AVATAR_MAP;
  function Avatar(props) {
    var className = props.className,
        url = props.url,
        gender = props.gender,
        isPad = props.isPad;
    var avatar = url || gender && AVATAR_MAP[gender] || DEFAULT_AVATAR;
    return React.createElement("div", {
      className: classnames('ph-avatar', className, {
        'is-pad': isPad
      })
    }, React.createElement("img", {
      src: avatar,
      alt: "avatar"
    }));
  }

  var token = '%[a-f0-9]{2}';
  var singleMatcher = new RegExp(token, 'gi');
  var multiMatcher = new RegExp('(' + token + ')+', 'gi');

  function decodeComponents(components, split) {
    try {
      // Try to decode the entire string first
      return decodeURIComponent(components.join(''));
    } catch (err) {// Do nothing
    }

    if (components.length === 1) {
      return components;
    }

    split = split || 1; // Split the array in 2 parts

    var left = components.slice(0, split);
    var right = components.slice(split);
    return Array.prototype.concat.call([], decodeComponents(left), decodeComponents(right));
  }

  function decode(input) {
    try {
      return decodeURIComponent(input);
    } catch (err) {
      var tokens = input.match(singleMatcher);

      for (var i = 1; i < tokens.length; i++) {
        input = decodeComponents(tokens, i).join('');
        tokens = input.match(singleMatcher);
      }

      return input;
    }
  }

  function customDecodeURIComponent(input) {
    // Keep track of all the replacements and prefill the map with the `BOM`
    var replaceMap = {
      '%FE%FF': "\uFFFD\uFFFD",
      '%FF%FE': "\uFFFD\uFFFD"
    };
    var match = multiMatcher.exec(input);

    while (match) {
      try {
        // Decode as big chunks as possible
        replaceMap[match[0]] = decodeURIComponent(match[0]);
      } catch (err) {
        var result = decode(match[0]);

        if (result !== match[0]) {
          replaceMap[match[0]] = result;
        }
      }

      match = multiMatcher.exec(input);
    } // Add `%C2` at the end of the map to make sure it does not replace the combinator before everything else


    replaceMap['%C2'] = "\uFFFD";
    var entries = Object.keys(replaceMap);

    for (var i = 0; i < entries.length; i++) {
      // Replace all decoded components
      var key = entries[i];
      input = input.replace(new RegExp(key, 'g'), replaceMap[key]);
    }

    return input;
  }

  var decodeUriComponent = function decodeUriComponent(encodedURI) {
    if (typeof encodedURI !== 'string') {
      throw new TypeError('Expected `encodedURI` to be of type `string`, got `' + _typeof(encodedURI) + '`');
    }

    try {
      encodedURI = encodedURI.replace(/\+/g, ' '); // Try the built in decoder first

      return decodeURIComponent(encodedURI);
    } catch (err) {
      // Fallback to a more advanced decoder
      return customDecodeURIComponent(encodedURI);
    }
  };

  var splitOnFirst = function splitOnFirst(string, separator) {
    if (!(typeof string === 'string' && typeof separator === 'string')) {
      throw new TypeError('Expected the arguments to be of type `string`');
    }

    if (separator === '') {
      return [string];
    }

    var separatorIndex = string.indexOf(separator);

    if (separatorIndex === -1) {
      return [string];
    }

    return [string.slice(0, separatorIndex), string.slice(separatorIndex + separator.length)];
  };

  function parserForArrayFormat(options) {
    var result;

    switch (options.arrayFormat) {
      case 'index':
        return function (key, value, accumulator) {
          result = /\[(\d*)\]$/.exec(key);
          key = key.replace(/\[\d*\]$/, '');

          if (!result) {
            accumulator[key] = value;
            return;
          }

          if (accumulator[key] === undefined) {
            accumulator[key] = {};
          }

          accumulator[key][result[1]] = value;
        };

      case 'bracket':
        return function (key, value, accumulator) {
          result = /(\[\])$/.exec(key);
          key = key.replace(/\[\]$/, '');

          if (!result) {
            accumulator[key] = value;
            return;
          }

          if (accumulator[key] === undefined) {
            accumulator[key] = [value];
            return;
          }

          accumulator[key] = [].concat(accumulator[key], value);
        };

      case 'comma':
        return function (key, value, accumulator) {
          var isArray = typeof value === 'string' && value.split('').indexOf(',') > -1;
          var newValue = isArray ? value.split(',') : value;
          accumulator[key] = newValue;
        };

      default:
        return function (key, value, accumulator) {
          if (accumulator[key] === undefined) {
            accumulator[key] = value;
            return;
          }

          accumulator[key] = [].concat(accumulator[key], value);
        };
    }
  }

  function decode$1(value, options) {
    if (options.decode) {
      return decodeUriComponent(value);
    }

    return value;
  }

  function keysSorter(input) {
    if (Array.isArray(input)) {
      return input.sort();
    }

    if (_typeof(input) === 'object') {
      return keysSorter(Object.keys(input)).sort(function (a, b) {
        return Number(a) - Number(b);
      }).map(function (key) {
        return input[key];
      });
    }

    return input;
  }

  function extract(input) {
    var queryStart = input.indexOf('?');

    if (queryStart === -1) {
      return '';
    }

    return input.slice(queryStart + 1);
  }

  function parse(input, options) {
    options = _extends({
      decode: true,
      arrayFormat: 'none'
    }, options);
    var formatter = parserForArrayFormat(options); // Create an object with no prototype

    var ret = Object.create(null);

    if (typeof input !== 'string') {
      return ret;
    }

    input = input.trim().replace(/^[?#&]/, '');

    if (!input) {
      return ret;
    }

    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = input.split('&')[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var param = _step.value;

        var _splitOnFirst = splitOnFirst(param.replace(/\+/g, ' '), '='),
            _splitOnFirst2 = _slicedToArray(_splitOnFirst, 2),
            key = _splitOnFirst2[0],
            value = _splitOnFirst2[1]; // Missing `=` should be `null`:
        // http://w3.org/TR/2012/WD-url-20120524/#collect-url-parameters


        value = value === undefined ? null : decode$1(value, options);
        formatter(decode$1(key, options), value, ret);
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return != null) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    return Object.keys(ret).sort().reduce(function (result, key) {
      var value = ret[key];

      if (Boolean(value) && _typeof(value) === 'object' && !Array.isArray(value)) {
        // Sort object keys, not values
        result[key] = keysSorter(value);
      } else {
        result[key] = value;
      }

      return result;
    }, Object.create(null));
  }

  var parseUrl = function parseUrl(input, options) {
    var hashStart = input.indexOf('#');

    if (hashStart !== -1) {
      input = input.slice(0, hashStart);
    }

    return {
      url: input.split('?')[0] || '',
      query: parse(extract(input), options)
    };
  };

  function parseParams() {
    var url = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : window.location.href;
    return parseUrl(url).query;
  }

  function addParams(url, params) {
    var oldParams = parseParams(url);
    var origin = url.split('?')[0];

    var newParams = _objectSpread({}, oldParams, params);

    var temp = Object.keys(newParams).reduce(function (acc, key) {
      var value = newParams[key]; // tslint:disable-next-line

      if (value != null) acc.push("".concat(key, "=").concat(encodeURIComponent(value)));
      return acc;
    }, []);
    return "".concat(origin, "?").concat(temp.join('&'));
  }

  (function (CanvasSubTypes) {
    CanvasSubTypes["Text"] = "text";
    CanvasSubTypes["Image"] = "image";
  })(exports.CanvasSubTypes || (exports.CanvasSubTypes = {}));

  var Canvas =
  /*#__PURE__*/
  function () {
    function Canvas(settings, options, element) {
      var _this = this;

      _classCallCheck(this, Canvas);

      this.imageList = {};
      this.ratio = 1;
      var width = settings.width,
          height = settings.height,
          bgColor = settings.bgColor,
          bgImage = settings.bgImage,
          usePrimaryFont = settings.usePrimaryFont,
          ratio = settings.ratio;
      if (ratio) this.ratio = ratio;
      this.canvas = element || document.createElement('canvas');
      this.canvas.width = width * this.ratio;
      this.canvas.height = height * this.ratio;
      this.canvas.setAttribute('style', '-moz-osx-font-smoothing: grayscale;-webkit-font-smoothing: antialiased;display:none');
      document.body.appendChild(this.canvas);
      this.ctx = this.canvas.getContext('2d', {
        alpha: false
      });
      this.settings = settings;
      this.options = options;

      if (bgColor) {
        this.drawRect(0, 0, width, height, {
          fillStyle: bgColor
        });
      }

      this.imageLoader = Promise.resolve();
      this.collectImage();
      var fontLoader = Promise.resolve();

      if (usePrimaryFont) {
        this.canvas.style.fontFamily = 'FZY4JW';
        var FONT_LOAD_MAX_TIME = 30000;
        var FONT_NAME = 'FZY4JW';
        var font = new FontFaceObserver(FONT_NAME);
        fontLoader = font.load(null, FONT_LOAD_MAX_TIME);
      }

      this.loader = Promise.all([this.imageLoader, fontLoader]);
      this.loader.then(function () {
        if (bgImage) {
          _this.drawImage({
            type: exports.CanvasSubTypes.Image,
            src: bgImage,
            position: {
              x: 0,
              y: 0,
              width: width,
              height: height
            }
          });
        }

        _this.initOptions();
      });
    }

    _createClass(Canvas, [{
      key: "getExtra",
      value: function getExtra(extra) {
        var result = _objectSpread({}, extra);

        if (result.font) {
          var fontSize = result.font.match(/\d+px/);
          fontSize = parseInt(fontSize, 10) * this.ratio;
          result.font = result.font.replace(/\d+px/, "".concat(fontSize, "px"));
        }

        return result;
      }
    }, {
      key: "initOptions",
      value: function initOptions() {
        var _this2 = this;

        this.options.forEach(function (option) {
          _this2.ctx.beginPath();

          _extends(_this2.ctx, _this2.getExtra(option.extra));

          switch (option.type) {
            case exports.CanvasSubTypes.Text:
              _this2.createText(option);

              break;

            case exports.CanvasSubTypes.Image:
              _this2.drawImage(option);

              break;
          }
        });
      }
    }, {
      key: "createText",
      value: function createText(item) {
        var _this3 = this;

        var position = item.position,
            text = item.text,
            maxWidth = item.maxWidth,
            lineHeight = item.lineHeight,
            styled = item.styled,
            extra = item.extra,
            del = item.del;
        var isDelete = Boolean(del);
        var x = position.x,
            y = position.y;
        this.ctx.lineWidth = 1;

        if (maxWidth && lineHeight) {
          var textArr = text.split('');
          var line = '';
          textArr.forEach(function (word, index) {
            var testLine = line + word;

            var metrics = _this3.ctx.measureText(testLine);

            var testWidth = metrics.width;

            if (testWidth > maxWidth * _this3.ratio && index) {
              _this3.drawText(line, x, y, isDelete);

              line = word;
              y += lineHeight;
            } else {
              line = testLine;
            }
          });
          this.drawText(line, x, y, isDelete);
        } else if (styled) {
          var _textArr = text.split('');

          var _line = '';

          _textArr.forEach(function (word) {
            if (word === '<') {
              _this3.drawText(_line, x, y, isDelete);

              x += _this3.ctx.measureText(_line).width / _this3.ratio;

              _extends(_this3.ctx, styled);

              _line = '';
            } else if (word === '>') {
              _this3.drawText(_line, x, y, isDelete);

              x += _this3.ctx.measureText(_line).width / _this3.ratio;

              _extends(_this3.ctx, _this3.getExtra(extra));

              _line = '';
            } else {
              _line += word;
            }
          });

          this.drawText(_line, x, y, isDelete);
        } else {
          this.drawText(text, x, y, isDelete);
        }
      }
    }, {
      key: "collectImage",
      value: function collectImage() {
        var _this4 = this;

        var settings = this.settings,
            options = this.options;
        var bgImage = settings.bgImage;
        if (bgImage) this.imageList[bgImage] = null;
        options.forEach(function (option) {
          if (option.type === exports.CanvasSubTypes.Image) {
            _this4.imageList[option.src] = null;
          }
        });
        this.imageLoader = Promise.all(Object.keys(this.imageList).map(function (imgSrc) {
          return new Promise(function (resolve, reject) {
            var image = new Image();

            if (!/^data:(.*);base64,/.test(imgSrc)) {
              image.setAttribute('crossOrigin', 'anonymous');
            }

            image.onload = function () {
              _this4.imageList[imgSrc] = image;
              resolve(image);
            };

            image.onerror = function () {
              reject(image);
            };

            image.src = imgSrc;
          });
        }));
      }
    }, {
      key: "drawImage",
      value: function drawImage(item) {
        var src = item.src,
            position = item.position;
        var x = position.x,
            y = position.y,
            _position$width = position.width,
            width = _position$width === void 0 ? this.imageList[src].width : _position$width,
            _position$height = position.height,
            height = _position$height === void 0 ? this.imageList[src].height : _position$height;
        this.ctx.drawImage(this.imageList[src], x * this.ratio, y * this.ratio, width * this.ratio, height * this.ratio);
      }
    }, {
      key: "drawText",
      value: function drawText(text, x, y, del) {
        this.ctx.fillText(text, x * this.ratio, y * this.ratio);

        if (del) {
          var _this$ctx$measureText = this.ctx.measureText(text),
              width = _this$ctx$measureText.width;

          var fontSizeMath = this.ctx.font.match(/\d+/);
          var fontSize = parseFloat(fontSizeMath && fontSizeMath[0] || '0');
          var verticalPos = this.ratio * y - fontSize / 2 + 1;
          this.ctx.moveTo(x * this.ratio, verticalPos);
          this.ctx.lineWidth = 2 * this.ratio;
          var fillStyle = this.ctx.fillStyle;
          this.ctx.strokeStyle = fillStyle;
          this.ctx.lineTo(this.ratio * x + width, verticalPos);
          this.ctx.stroke();
        }
      }
    }, {
      key: "drawRect",
      value: function drawRect(x, y, width, height, options) {
        var fillStyle = options.fillStyle,
            strokeStyle = options.strokeStyle;
        this.ctx.beginPath();
        this.ctx.rect(x * this.ratio, y * this.ratio, width * this.ratio, height * this.ratio);

        if (fillStyle) {
          this.ctx.fillStyle = fillStyle;
          this.ctx.fill();
        }

        if (strokeStyle) {
          this.ctx.strokeStyle = strokeStyle;
          this.ctx.stroke();
        }
      }
    }, {
      key: "getBase64Data",
      value: function getBase64Data() {
        var _this5 = this;

        return this.loader.then(function () {
          return _this5.canvas.toDataURL('image/png', 1.0);
        });
      }
    }]);

    return Canvas;
  }();
  /** 获取图片base64信息 */


  function getImage(settings, options, element) {
    var image = new Canvas(settings, options, element);
    return image.getBase64Data();
  }

  var ua = window.navigator.userAgent.toLowerCase();
  var isWeixin = /micromessenger/.test(ua);
  var isQQ = /qq\//.test(ua);
  var isX5 = /tbs\//.test(ua);
  var isWeibo = /weibo/.test(ua);
  var isAndroid = /android/.test(ua);
  var isIOS = /ip(ad|hone|od)/.test(ua);
  /**
   * @see https://git.llsapp.com/docs/jsbridge-api-doc/blob/master/README.md#-useragent
   */

  var isDarwin = /darwin\//.test(ua);
  var isSprout = /sprout\//.test(ua);
  var isTelis = /telis\//.test(ua);
  var isVira = /vira\//.test(ua);

  var isLingome = function () {
    // NOTE: for client version >= 5.9
    var uaMatched = /lingome\//.test(ua); // NOTE: for client version < 5.9

    return uaMatched || function legacyCheck() {
      if (isAndroid && window.LLSAndroid) return true;
      return isIOS && window.webkit && window.webkit.messageHandlers && window.webkit.messageHandlers.LLSiOS;
    }();
  }();

  var isHybrid = isLingome || isDarwin || isTelis || isVira || isSprout;

  function versionCompare(v1, v2, options) {
    var lexicographical = options && options.lexicographical;
    var zeroExtend = options && options.zeroExtend;
    var v1parts = v1.split('.');
    var v2parts = v2.split('.');

    function isValidPart(x) {
      return (lexicographical ? /^\d+[A-Za-z]*$/ : /^\d+$/).test(x);
    }

    if (!v1parts.every(isValidPart) || !v2parts.every(isValidPart)) {
      return NaN;
    }

    if (zeroExtend) {
      while (v1parts.length < v2parts.length) {
        v1parts.push('0');
      }

      while (v2parts.length < v1parts.length) {
        v2parts.push('0');
      }
    }

    if (!lexicographical) {
      v1parts = v1parts.map(Number);
      v2parts = v2parts.map(Number);
    }

    for (var i = 0; i < v1parts.length; ++i) {
      if (v2parts.length === i) {
        return 1;
      }

      if (v1parts[i] !== v2parts[i]) {
        if (v1parts[i] > v2parts[i]) {
          return 1;
        }

        return -1;
      }
    }

    if (v1parts.length !== v2parts.length) {
      return -1;
    }

    return 0;
  }
  /**
   * 获得安卓浏览器版本
   * @memberof UserAgent
   * @returns {string | boolean} 版本, 如果不是安卓浏览器就返回 `false`
   *
   */


  function getAndroidVersion() {
    var match = ua.match(/android\s([0-9.]*)/);
    return match ? match[1] : false;
  }
  /**
   * 获得 iOS 浏览器的版本
   * @memberof UserAgent
   * @returns {Array<number> | boolean} 版本, 如果不是 iOS 浏览器就返回 `false`
   */


  function getIOSVersions() {
    // supports iOS 2.0 and later
    // code from https://stackoverflow.com/questions/8348139/detect-ios-version-less-than-5-with-javascript
    if (/iP(hone|od|ad)/.test(navigator.platform)) {
      var v = navigator.appVersion.match(/OS (\d+)_(\d+)_?(\d+)?/);
      return [parseInt(v[1], 10), parseInt(v[2], 10), parseInt(v[3] || 0, 10)];
    }

    return false;
  }
  /**
   * 接下来这些以 `is` 开头的例如 `isHybrid`, `isAndroid` 等等都是 `boolean`, 在浏览器加载完成之后其值就固定了`.
   * @module UserAgent
   * @type {Object}
   * @example
   * <caption>variables</caption>
   *
   * import { isHybrid } from 'llsjs/UserAgent';
   * console.log(isHybrid); // true or false
   *
   * import UserAgent from 'llsjs/UserAgent';
   * console.log(UserAgent.isIOS); // true or false
   */


  var UserAgent = {
    isWeixin: isWeixin,
    isQQ: isQQ,
    isX5: isX5,
    isIOS: isIOS,
    isAndroid: isAndroid,
    isWeibo: isWeibo,
    isLingome: isLingome,
    isVira: isVira,
    isDarwin: isDarwin,
    isSprout: isSprout,
    isTelis: isTelis,
    isHybrid: isHybrid,
    versionCompare: versionCompare,
    getAndroidVersion: getAndroidVersion,
    getIOSVersions: getIOSVersions
  };

  var PHONE_IMAGE = [{
    375: 'https://cdn.llscdn.com/phonics-ui/phone-empty.png',
    750: 'https://cdn.llscdn.com/phonics-ui/phone-empty@2x.png',
    1125: 'https://cdn.llscdn.com/phonics-ui/phone-empty@3x.png',
    height: "".concat(168 / PHONE_RATIO, "rem")
  }];
  var PAD_IMAGE = [{
    1024: 'https://cdn.llscdn.com/phonics-ui/phone-empty@3x.png',
    2048: 'https://cdn.llscdn.com/phonics-ui/phone-empty@3x.png',
    3072: 'https://cdn.llscdn.com/phonics-ui/phone-empty@3x.png',
    height: "".concat(168 / PAD_RATIO, "rem")
  }];

  function reload() {
    window.location.reload();
  }

  function PageFail(props) {
    var isPad = props.isPad,
        className = props.className;
    return React__default.createElement("div", {
      className: classnames('ph-page-fail', className, {
        'is-pad': isPad
      })
    }, React__default.createElement(Imager, {
      className: "fail-image",
      isPad: isPad,
      imgList: isPad ? PAD_IMAGE : PHONE_IMAGE
    }), React__default.createElement("p", {
      className: "fail-text"
    }, "\u52A0\u8F7D\u5931\u8D25"), React__default.createElement("button", {
      className: "reload-btn",
      onClick: reload
    }, "\u91CD\u65B0\u52A0\u8F7D"));
  }

  var PHONE_IMAGE$1 = [{
    375: 'https://cdn.llscdn.com/sprout/assets/invalidName_phone.png',
    750: 'https://cdn.llscdn.com/sprout/assets/invalidName_phone@2x.png',
    1125: 'https://cdn.llscdn.com/sprout/assets/invalidName_phone@3x.png',
    height: "".concat(62 / PHONE_RATIO, "rem")
  }];
  var PAD_IMAGE$1 = [{
    1024: 'https://cdn.llscdn.com/sprout/assets/invalidName_pad.png',
    2048: 'https://cdn.llscdn.com/sprout/assets/invalidName_pad@2x.png',
    3072: 'https://cdn.llscdn.com/sprout/assets/invalidName_pad@3x.png',
    height: "".concat(68 / PAD_RATIO, "rem")
  }];
  function PageLoading(props) {
    var _ref = props || {},
        _ref$isPad = _ref.isPad,
        isPad = _ref$isPad === void 0 ? false : _ref$isPad,
        _ref$className = _ref.className,
        className = _ref$className === void 0 ? '' : _ref$className;

    return React__default.createElement("div", {
      className: classnames('ph-page-loading', className, {
        'is-pad': isPad
      })
    }, React__default.createElement(Imager, {
      className: "loading-image",
      isPad: isPad,
      imgList: isPad ? PAD_IMAGE$1 : PHONE_IMAGE$1
    }), React__default.createElement("div", {
      className: "loading-text"
    }, "\u52AA\u529B\u52A0\u8F7D\u4E2D"));
  }
  function PageLoading$1 (props) {
    var loadingEl;
    return {
      show: function show() {
        var div = document.createElement('div');
        document.body.appendChild(div);
        ReactDOM.render(React__default.createElement(PageLoading, _extends({}, props)), div);
        loadingEl = div;
      },
      hide: function hide() {
        if (loadingEl) document.body.removeChild(loadingEl);
        loadingEl = null;
      }
    };
  }

  var getType = function getType(v) {
    return Object.prototype.toString.call(v);
  };
  var isFunction = function isFunction(v) {
    return getType(v) === '[object Function]';
  };
  var isObject = function isObject(v) {
    return getType(v) === '[object Object]';
  };
  var getIsPadDisplay = function getIsPadDisplay() {
    return window.innerWidth >= 1024 && window.innerWidth > window.innerHeight;
  };
  var noop = function noop() {};
  function loadPrimaryFont() {
    var el = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : document.body;
    var FONT_LOAD_MAX_TIME = 30000;
    var FONT_NAME = 'FZY4JW';
    var font = new FontFaceObserver(FONT_NAME);
    font.load(null, FONT_LOAD_MAX_TIME).then(function () {
      el.style.fontFamily = FONT_NAME;
    }, noop);
  }
  var toArray = function toArray(target) {
    return Array.prototype.slice.call(target);
  };
  var preloadImage = function preloadImage(imgList) {
    return Promise.all(imgList.map(loadImage));
  };
  var loadImage = function loadImage(imgSrc) {
    return new Promise(function (resolve, reject) {
      var img = new Image();
      img.src = imgSrc;

      img.onload = function () {
        resolve();
      };

      img.onerror = function () {
        reject();
      };
    });
  };

  function setGangFour(_ref) {
    var deviceId = _ref.deviceId,
        sDeviceId = _ref.sDeviceId,
        token = _ref.token,
        appId = _ref.appId,
        userLogin = _ref.userLogin;
    localStorage.setItem('TOKEN', JSON.stringify(token));
    localStorage.setItem('APP_ID', JSON.stringify(appId));
    localStorage.setItem('DEVICE_ID', JSON.stringify(deviceId));
    localStorage.setItem('S_DEVICE_ID', JSON.stringify(sDeviceId));
    localStorage.setItem('USER_LOGIN', JSON.stringify(userLogin));
  }

  function getVisibilityName() {
    var hidden = '';
    var visibilityChange = '';

    if (typeof document.hidden !== 'undefined') {
      hidden = 'hidden';
      visibilityChange = 'visibilitychange';
    } else if (typeof document.msHidden !== 'undefined') {
      hidden = 'msHidden';
      visibilityChange = 'msvisibilitychange';
    } else if (typeof document.webkitHidden !== 'undefined') {
      hidden = 'webkitHidden';
      visibilityChange = 'webkitvisibilitychange';
    }

    return {
      hidden: hidden,
      visibilityChange: visibilityChange
    };
  }

  var _getVisibilityName = getVisibilityName(),
      hidden = _getVisibilityName.hidden,
      visibilityChange = _getVisibilityName.visibilityChange;

  function PageWrapper(target) {
    // TODO: fix type
    var usePrimaryFont = false;
    var notJudgePad = false;
    var useAuthInApp = false;
    var preloadSync = false;
    var preload = [];

    function getAppAuth() {
      var _parseParams = parseParams(),
          deviceId = _parseParams.deviceId,
          sDeviceId = _parseParams.sDeviceId,
          token = _parseParams.token,
          appId = _parseParams.appId;

      if (deviceId && sDeviceId && token && appId) {
        var result = {
          deviceId: deviceId,
          sDeviceId: sDeviceId,
          token: token,
          appId: appId,
          userLogin: ''
        };
        setGangFour(result);
        return Promise.resolve(result);
      } else if (UserAgent.isHybrid) {
        return bard.invoke('getAuthData').then(function (_ref2) {
          var deviceId = _ref2.deviceId,
              sDeviceId = _ref2.sDeviceId,
              token = _ref2.token,
              appId = _ref2.appId,
              userLogin = _ref2.userLogin;
          var result = {
            deviceId: deviceId,
            sDeviceId: sDeviceId,
            token: token,
            appId: appId,
            userLogin: userLogin
          };
          setGangFour(result);
          return result;
        });
      } else {
        return Promise.resolve();
      }
    }

    var pageHoc = function pageHoc(OriginComponent) {
      var hasFetch = isFunction(OriginComponent.fetch);

      var PhPageWrapper =
      /*#__PURE__*/
      function (_Component) {
        _inherits(PhPageWrapper, _Component);

        function PhPageWrapper() {
          var _this;

          _classCallCheck(this, PhPageWrapper);

          _this = _possibleConstructorReturn(this, _getPrototypeOf(PhPageWrapper).apply(this, arguments));
          _this.state = {
            loading: hasFetch || useAuthInApp || !!preload.length,
            auth: null,
            data: null,
            error: null
          };
          _this.isPad = getIsPadDisplay();

          _this.onOrientationChange = function () {
            window.location.reload();
          };

          return _this;
        }

        _createClass(PhPageWrapper, [{
          key: "componentWillMount",
          value: function componentWillMount() {
            var _this2 = this;

            if (usePrimaryFont) loadPrimaryFont();
            var showLoading = this.state.loading;
            if (!showLoading) return;
            var isPad = this.isPad;
            var loading = PageLoading$1({
              isPad: isPad
            });
            loading.show();
            var auth = null;
            var data = null;
            var authPromise = useAuthInApp ? getAppAuth() : Promise.resolve(null);
            var loadImage = preloadImage(preload).catch(function (_) {
              return _;
            });
            var imgPromise = preloadSync ? loadImage : Promise.resolve(null);
            Promise.all([authPromise, imgPromise]).then(function (_ref3) {
              var _ref4 = _slicedToArray(_ref3, 1),
                  res = _ref4[0];

              if (res) auth = res;

              if (hasFetch) {
                return OriginComponent.fetch(_objectSpread({}, _this2.props, {
                  auth: res
                })).then(function (d) {
                  return data = d;
                });
              }
            }).then(function () {
              _this2.setState({
                data: data,
                auth: auth,
                loading: false
              });

              loading.hide();
            }).catch(function (err) {
              _this2.setState({
                error: err || true,
                loading: false
              });

              loading.hide();
            });
          }
        }, {
          key: "handleVChange",
          value: function handleVChange() {
            var videos = toArray(document.querySelectorAll('video'));
            var audios = toArray(document.querySelectorAll('audio'));

            if (document[hidden]) {
              videos.forEach(function (video) {
                video.pause();
              });
              audios.forEach(function (audio) {
                audio.pause();
              });
            }
          }
        }, {
          key: "componentDidMount",
          value: function componentDidMount() {
            document.addEventListener(visibilityChange, this.handleVChange);

            if (!notJudgePad) {
              if (this.isPad) document.body.classList.add('ph-pad-body');
              window.addEventListener('orientationchange', this.onOrientationChange);
            }
          }
        }, {
          key: "componentWillUnmount",
          value: function componentWillUnmount() {
            document.addEventListener(visibilityChange, this.handleVChange);

            if (!notJudgePad) {
              window.removeEventListener('orientationchange', this.onOrientationChange);
            }
          }
        }, {
          key: "render",
          value: function render() {
            var _this$state = this.state,
                loading = _this$state.loading,
                data = _this$state.data,
                error = _this$state.error,
                auth = _this$state.auth;
            var jest = this.props.jest;

            if (jest) {
              var _this$props = this.props,
                  _jest = _this$props.jest,
                  _props = _objectWithoutProperties(_this$props, ["jest"]);

              return React__default.createElement(OriginComponent, _extends({}, _props));
            }

            if (loading) return null;
            if (error) return React__default.createElement(PageFail, {
              isPad: this.isPad
            });

            var props = _objectSpread({
              data: data
            }, this.props, {
              auth: auth
            });

            if (!notJudgePad) props.isPad = this.isPad;
            return React__default.createElement(OriginComponent, _extends({}, props));
          }
        }]);

        return PhPageWrapper;
      }(React.Component);

      return PhPageWrapper;
    };

    if (target && target.prototype instanceof React.Component) {
      return pageHoc(target);
    } else {
      if (isObject(target)) {
        usePrimaryFont = !!target.usePrimaryFont;
        notJudgePad = !!target.notJudgePad;
        useAuthInApp = !!target.useAuthInApp;
        preload = target.preload || [];
        preloadSync = target.preloadSync;
      }

      return pageHoc;
    }
  }

  var _isObject = function _isObject(it) {
    return _typeof(it) === 'object' ? it !== null : typeof it === 'function';
  };

  var toString = {}.toString;

  var _cof = function _cof(it) {
    return toString.call(it).slice(8, -1);
  };

  var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

  function createCommonjsModule(fn, module) {
  	return module = { exports: {} }, fn(module, module.exports), module.exports;
  }

  var _core = createCommonjsModule(function (module) {
    var core = module.exports = {
      version: '2.6.2'
    };
    if (typeof __e == 'number') __e = core; // eslint-disable-line no-undef
  });
  var _core_1 = _core.version;

  var _global = createCommonjsModule(function (module) {
    // https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
    var global = module.exports = typeof window != 'undefined' && window.Math == Math ? window : typeof self != 'undefined' && self.Math == Math ? self // eslint-disable-next-line no-new-func
    : Function('return this')();
    if (typeof __g == 'number') __g = global; // eslint-disable-line no-undef
  });

  var _shared = createCommonjsModule(function (module) {
    var SHARED = '__core-js_shared__';
    var store = _global[SHARED] || (_global[SHARED] = {});
    (module.exports = function (key, value) {
      return store[key] || (store[key] = value !== undefined ? value : {});
    })('versions', []).push({
      version: _core.version,
      mode: 'global',
      copyright: '© 2019 Denis Pushkarev (zloirock.ru)'
    });
  });

  var id = 0;
  var px = Math.random();

  var _uid = function _uid(key) {
    return 'Symbol('.concat(key === undefined ? '' : key, ')_', (++id + px).toString(36));
  };

  var _wks = createCommonjsModule(function (module) {
    var store = _shared('wks');
    var _Symbol = _global.Symbol;
    var USE_SYMBOL = typeof _Symbol == 'function';

    var $exports = module.exports = function (name) {
      return store[name] || (store[name] = USE_SYMBOL && _Symbol[name] || (USE_SYMBOL ? _Symbol : _uid)('Symbol.' + name));
    };

    $exports.store = store;
  });

  var MATCH = _wks('match');

  var _isRegexp = function _isRegexp(it) {
    var isRegExp;
    return _isObject(it) && ((isRegExp = it[MATCH]) !== undefined ? !!isRegExp : _cof(it) == 'RegExp');
  };

  var _anObject = function _anObject(it) {
    if (!_isObject(it)) throw TypeError(it + ' is not an object!');
    return it;
  };

  var _aFunction = function _aFunction(it) {
    if (typeof it != 'function') throw TypeError(it + ' is not a function!');
    return it;
  };

  var SPECIES = _wks('species');

  var _speciesConstructor = function _speciesConstructor(O, D) {
    var C = _anObject(O).constructor;
    var S;
    return C === undefined || (S = _anObject(C)[SPECIES]) == undefined ? D : _aFunction(S);
  };

  // 7.1.4 ToInteger
  var ceil = Math.ceil;
  var floor = Math.floor;

  var _toInteger = function _toInteger(it) {
    return isNaN(it = +it) ? 0 : (it > 0 ? floor : ceil)(it);
  };

  // 7.2.1 RequireObjectCoercible(argument)
  var _defined = function _defined(it) {
    if (it == undefined) throw TypeError("Can't call method on  " + it);
    return it;
  };

  // false -> String#codePointAt

  var _stringAt = function _stringAt(TO_STRING) {
    return function (that, pos) {
      var s = String(_defined(that));
      var i = _toInteger(pos);
      var l = s.length;
      var a, b;
      if (i < 0 || i >= l) return TO_STRING ? '' : undefined;
      a = s.charCodeAt(i);
      return a < 0xd800 || a > 0xdbff || i + 1 === l || (b = s.charCodeAt(i + 1)) < 0xdc00 || b > 0xdfff ? TO_STRING ? s.charAt(i) : a : TO_STRING ? s.slice(i, i + 2) : (a - 0xd800 << 10) + (b - 0xdc00) + 0x10000;
    };
  };

  var at = _stringAt(true); // `AdvanceStringIndex` abstract operation
  // https://tc39.github.io/ecma262/#sec-advancestringindex

  var _advanceStringIndex = function _advanceStringIndex(S, index, unicode) {
    return index + (unicode ? at(S, index).length : 1);
  };

  var min = Math.min;

  var _toLength = function _toLength(it) {
    return it > 0 ? min(_toInteger(it), 0x1fffffffffffff) : 0; // pow(2, 53) - 1 == 9007199254740991
  };

  var TAG = _wks('toStringTag'); // ES3 wrong here

  var ARG = _cof(function () {
    return arguments;
  }()) == 'Arguments'; // fallback for IE11 Script Access Denied error

  var tryGet = function tryGet(it, key) {
    try {
      return it[key];
    } catch (e) {
      /* empty */
    }
  };

  var _classof = function _classof(it) {
    var O, T, B;
    return it === undefined ? 'Undefined' : it === null ? 'Null' // @@toStringTag case
    : typeof (T = tryGet(O = Object(it), TAG)) == 'string' ? T // builtinTag case
    : ARG ? _cof(O) // ES3 arguments fallback
    : (B = _cof(O)) == 'Object' && typeof O.callee == 'function' ? 'Arguments' : B;
  };

  var builtinExec = RegExp.prototype.exec; // `RegExpExec` abstract operation
  // https://tc39.github.io/ecma262/#sec-regexpexec

  var _regexpExecAbstract = function _regexpExecAbstract(R, S) {
    var exec = R.exec;

    if (typeof exec === 'function') {
      var result = exec.call(R, S);

      if (_typeof(result) !== 'object') {
        throw new TypeError('RegExp exec method returned something other than an Object or null');
      }

      return result;
    }

    if (_classof(R) !== 'RegExp') {
      throw new TypeError('RegExp#exec called on incompatible receiver');
    }

    return builtinExec.call(R, S);
  };

  var _flags = function _flags() {
    var that = _anObject(this);
    var result = '';
    if (that.global) result += 'g';
    if (that.ignoreCase) result += 'i';
    if (that.multiline) result += 'm';
    if (that.unicode) result += 'u';
    if (that.sticky) result += 'y';
    return result;
  };

  var nativeExec = RegExp.prototype.exec; // This always refers to the native implementation, because the
  // String#replace polyfill uses ./fix-regexp-well-known-symbol-logic.js,
  // which loads this file before patching the method.

  var nativeReplace = String.prototype.replace;
  var patchedExec = nativeExec;
  var LAST_INDEX = 'lastIndex';

  var UPDATES_LAST_INDEX_WRONG = function () {
    var re1 = /a/,
        re2 = /b*/g;
    nativeExec.call(re1, 'a');
    nativeExec.call(re2, 'a');
    return re1[LAST_INDEX] !== 0 || re2[LAST_INDEX] !== 0;
  }(); // nonparticipating capturing group, copied from es5-shim's String#split patch.


  var NPCG_INCLUDED = /()??/.exec('')[1] !== undefined;
  var PATCH = UPDATES_LAST_INDEX_WRONG || NPCG_INCLUDED;

  if (PATCH) {
    patchedExec = function exec(str) {
      var re = this;
      var lastIndex, reCopy, match, i;

      if (NPCG_INCLUDED) {
        reCopy = new RegExp('^' + re.source + '$(?!\\s)', _flags.call(re));
      }

      if (UPDATES_LAST_INDEX_WRONG) lastIndex = re[LAST_INDEX];
      match = nativeExec.call(re, str);

      if (UPDATES_LAST_INDEX_WRONG && match) {
        re[LAST_INDEX] = re.global ? match.index + match[0].length : lastIndex;
      }

      if (NPCG_INCLUDED && match && match.length > 1) {
        // Fix browsers whose `exec` methods don't consistently return `undefined`
        // for NPCG, like IE8. NOTE: This doesn' work for /(.?)?/
        // eslint-disable-next-line no-loop-func
        nativeReplace.call(match[0], reCopy, function () {
          for (i = 1; i < arguments.length - 2; i++) {
            if (arguments[i] === undefined) match[i] = undefined;
          }
        });
      }

      return match;
    };
  }

  var _regexpExec = patchedExec;

  var _fails = function _fails(exec) {
    try {
      return !!exec();
    } catch (e) {
      return true;
    }
  };

  var _descriptors = !_fails(function () {
    return Object.defineProperty({}, 'a', {
      get: function get() {
        return 7;
      }
    }).a != 7;
  });

  var document$1 = _global.document; // typeof document.createElement is 'object' in old IE

  var is = _isObject(document$1) && _isObject(document$1.createElement);

  var _domCreate = function _domCreate(it) {
    return is ? document$1.createElement(it) : {};
  };

  var _ie8DomDefine = !_descriptors && !_fails(function () {
    return Object.defineProperty(_domCreate('div'), 'a', {
      get: function get() {
        return 7;
      }
    }).a != 7;
  });

  // instead of the ES6 spec version, we didn't implement @@toPrimitive case
  // and the second argument - flag - preferred type is a string

  var _toPrimitive = function _toPrimitive(it, S) {
    if (!_isObject(it)) return it;
    var fn, val;
    if (S && typeof (fn = it.toString) == 'function' && !_isObject(val = fn.call(it))) return val;
    if (typeof (fn = it.valueOf) == 'function' && !_isObject(val = fn.call(it))) return val;
    if (!S && typeof (fn = it.toString) == 'function' && !_isObject(val = fn.call(it))) return val;
    throw TypeError("Can't convert object to primitive value");
  };

  var dP = Object.defineProperty;
  var f = _descriptors ? Object.defineProperty : function defineProperty(O, P, Attributes) {
    _anObject(O);
    P = _toPrimitive(P, true);
    _anObject(Attributes);
    if (_ie8DomDefine) try {
      return dP(O, P, Attributes);
    } catch (e) {
      /* empty */
    }
    if ('get' in Attributes || 'set' in Attributes) throw TypeError('Accessors not supported!');
    if ('value' in Attributes) O[P] = Attributes.value;
    return O;
  };
  var _objectDp = {
    f: f
  };

  var _propertyDesc = function _propertyDesc(bitmap, value) {
    return {
      enumerable: !(bitmap & 1),
      configurable: !(bitmap & 2),
      writable: !(bitmap & 4),
      value: value
    };
  };

  var _hide = _descriptors ? function (object, key, value) {
    return _objectDp.f(object, key, _propertyDesc(1, value));
  } : function (object, key, value) {
    object[key] = value;
    return object;
  };

  var hasOwnProperty = {}.hasOwnProperty;

  var _has = function _has(it, key) {
    return hasOwnProperty.call(it, key);
  };

  var _redefine = createCommonjsModule(function (module) {
    var SRC = _uid('src');
    var TO_STRING = 'toString';
    var $toString = Function[TO_STRING];
    var TPL = ('' + $toString).split(TO_STRING);

    _core.inspectSource = function (it) {
      return $toString.call(it);
    };

    (module.exports = function (O, key, val, safe) {
      var isFunction = typeof val == 'function';
      if (isFunction) _has(val, 'name') || _hide(val, 'name', key);
      if (O[key] === val) return;
      if (isFunction) _has(val, SRC) || _hide(val, SRC, O[key] ? '' + O[key] : TPL.join(String(key)));

      if (O === _global) {
        O[key] = val;
      } else if (!safe) {
        delete O[key];
        _hide(O, key, val);
      } else if (O[key]) {
        O[key] = val;
      } else {
        _hide(O, key, val);
      } // add fake Function#toString for correct work wrapped methods / constructors with methods like LoDash isNative

    })(Function.prototype, TO_STRING, function toString() {
      return typeof this == 'function' && this[SRC] || $toString.call(this);
    });
  });

  var _ctx = function _ctx(fn, that, length) {
    _aFunction(fn);
    if (that === undefined) return fn;

    switch (length) {
      case 1:
        return function (a) {
          return fn.call(that, a);
        };

      case 2:
        return function (a, b) {
          return fn.call(that, a, b);
        };

      case 3:
        return function (a, b, c) {
          return fn.call(that, a, b, c);
        };
    }

    return function ()
    /* ...args */
    {
      return fn.apply(that, arguments);
    };
  };

  var PROTOTYPE = 'prototype';

  var $export = function $export(type, name, source) {
    var IS_FORCED = type & $export.F;
    var IS_GLOBAL = type & $export.G;
    var IS_STATIC = type & $export.S;
    var IS_PROTO = type & $export.P;
    var IS_BIND = type & $export.B;
    var target = IS_GLOBAL ? _global : IS_STATIC ? _global[name] || (_global[name] = {}) : (_global[name] || {})[PROTOTYPE];
    var exports = IS_GLOBAL ? _core : _core[name] || (_core[name] = {});
    var expProto = exports[PROTOTYPE] || (exports[PROTOTYPE] = {});
    var key, own, out, exp;
    if (IS_GLOBAL) source = name;

    for (key in source) {
      // contains in native
      own = !IS_FORCED && target && target[key] !== undefined; // export native or passed

      out = (own ? target : source)[key]; // bind timers to global for call from export context

      exp = IS_BIND && own ? _ctx(out, _global) : IS_PROTO && typeof out == 'function' ? _ctx(Function.call, out) : out; // extend global

      if (target) _redefine(target, key, out, type & $export.U); // export

      if (exports[key] != out) _hide(exports, key, exp);
      if (IS_PROTO && expProto[key] != out) expProto[key] = out;
    }
  };

  _global.core = _core; // type bitmap

  $export.F = 1; // forced

  $export.G = 2; // global

  $export.S = 4; // static

  $export.P = 8; // proto

  $export.B = 16; // bind

  $export.W = 32; // wrap

  $export.U = 64; // safe

  $export.R = 128; // real proto method for `library`

  var _export = $export;

  _export({
    target: 'RegExp',
    proto: true,
    forced: _regexpExec !== /./.exec
  }, {
    exec: _regexpExec
  });

  var SPECIES$1 = _wks('species');
  var REPLACE_SUPPORTS_NAMED_GROUPS = !_fails(function () {
    // #replace needs built-in support for named groups.
    // #match works fine because it just return the exec results, even if it has
    // a "grops" property.
    var re = /./;

    re.exec = function () {
      var result = [];
      result.groups = {
        a: '7'
      };
      return result;
    };

    return ''.replace(re, '$<a>') !== '7';
  });

  var SPLIT_WORKS_WITH_OVERWRITTEN_EXEC = function () {
    // Chrome 51 has a buggy "split" implementation when RegExp#exec !== nativeExec
    var re = /(?:)/;
    var originalExec = re.exec;

    re.exec = function () {
      return originalExec.apply(this, arguments);
    };

    var result = 'ab'.split(re);
    return result.length === 2 && result[0] === 'a' && result[1] === 'b';
  }();

  var _fixReWks = function _fixReWks(KEY, length, exec) {
    var SYMBOL = _wks(KEY);
    var DELEGATES_TO_SYMBOL = !_fails(function () {
      // String methods call symbol-named RegEp methods
      var O = {};

      O[SYMBOL] = function () {
        return 7;
      };

      return ''[KEY](O) != 7;
    });
    var DELEGATES_TO_EXEC = DELEGATES_TO_SYMBOL ? !_fails(function () {
      // Symbol-named RegExp methods call .exec
      var execCalled = false;
      var re = /a/;

      re.exec = function () {
        execCalled = true;
        return null;
      };

      if (KEY === 'split') {
        // RegExp[@@split] doesn't call the regex's exec method, but first creates
        // a new one. We need to return the patched regex when creating the new one.
        re.constructor = {};

        re.constructor[SPECIES$1] = function () {
          return re;
        };
      }

      re[SYMBOL]('');
      return !execCalled;
    }) : undefined;

    if (!DELEGATES_TO_SYMBOL || !DELEGATES_TO_EXEC || KEY === 'replace' && !REPLACE_SUPPORTS_NAMED_GROUPS || KEY === 'split' && !SPLIT_WORKS_WITH_OVERWRITTEN_EXEC) {
      var nativeRegExpMethod = /./[SYMBOL];
      var fns = exec(_defined, SYMBOL, ''[KEY], function maybeCallNative(nativeMethod, regexp, str, arg2, forceStringMethod) {
        if (regexp.exec === _regexpExec) {
          if (DELEGATES_TO_SYMBOL && !forceStringMethod) {
            // The native String method already delegates to @@method (this
            // polyfilled function), leasing to infinite recursion.
            // We avoid it by directly calling the native @@method method.
            return {
              done: true,
              value: nativeRegExpMethod.call(regexp, str, arg2)
            };
          }

          return {
            done: true,
            value: nativeMethod.call(str, regexp, arg2)
          };
        }

        return {
          done: false
        };
      });
      var strfn = fns[0];
      var rxfn = fns[1];
      _redefine(String.prototype, KEY, strfn);
      _hide(RegExp.prototype, SYMBOL, length == 2 // 21.2.5.8 RegExp.prototype[@@replace](string, replaceValue)
      // 21.2.5.11 RegExp.prototype[@@split](string, limit)
      ? function (string, arg) {
        return rxfn.call(string, this, arg);
      } // 21.2.5.6 RegExp.prototype[@@match](string)
      // 21.2.5.9 RegExp.prototype[@@search](string)
      : function (string) {
        return rxfn.call(string, this);
      });
    }
  };

  var $min = Math.min;
  var $push = [].push;
  var $SPLIT = 'split';
  var LENGTH = 'length';
  var LAST_INDEX$1 = 'lastIndex'; // eslint-disable-next-line no-empty

  var SUPPORTS_Y = !!function () {
    try {
      return new RegExp('x', 'y');
    } catch (e) {}
  }(); // @@split logic

  _fixReWks('split', 2, function (defined, SPLIT, $split, maybeCallNative) {
    var internalSplit;

    if ('abbc'[$SPLIT](/(b)*/)[1] == 'c' || 'test'[$SPLIT](/(?:)/, -1)[LENGTH] != 4 || 'ab'[$SPLIT](/(?:ab)*/)[LENGTH] != 2 || '.'[$SPLIT](/(.?)(.?)/)[LENGTH] != 4 || '.'[$SPLIT](/()()/)[LENGTH] > 1 || ''[$SPLIT](/.?/)[LENGTH]) {
      // based on es5-shim implementation, need to rework it
      internalSplit = function internalSplit(separator, limit) {
        var string = String(this);
        if (separator === undefined && limit === 0) return []; // If `separator` is not a regex, use native split

        if (!_isRegexp(separator)) return $split.call(string, separator, limit);
        var output = [];
        var flags = (separator.ignoreCase ? 'i' : '') + (separator.multiline ? 'm' : '') + (separator.unicode ? 'u' : '') + (separator.sticky ? 'y' : '');
        var lastLastIndex = 0;
        var splitLimit = limit === undefined ? 4294967295 : limit >>> 0; // Make `global` and avoid `lastIndex` issues by working with a copy

        var separatorCopy = new RegExp(separator.source, flags + 'g');
        var match, lastIndex, lastLength;

        while (match = _regexpExec.call(separatorCopy, string)) {
          lastIndex = separatorCopy[LAST_INDEX$1];

          if (lastIndex > lastLastIndex) {
            output.push(string.slice(lastLastIndex, match.index));
            if (match[LENGTH] > 1 && match.index < string[LENGTH]) $push.apply(output, match.slice(1));
            lastLength = match[0][LENGTH];
            lastLastIndex = lastIndex;
            if (output[LENGTH] >= splitLimit) break;
          }

          if (separatorCopy[LAST_INDEX$1] === match.index) separatorCopy[LAST_INDEX$1]++; // Avoid an infinite loop
        }

        if (lastLastIndex === string[LENGTH]) {
          if (lastLength || !separatorCopy.test('')) output.push('');
        } else output.push(string.slice(lastLastIndex));

        return output[LENGTH] > splitLimit ? output.slice(0, splitLimit) : output;
      }; // Chakra, V8

    } else if ('0'[$SPLIT](undefined, 0)[LENGTH]) {
      internalSplit = function internalSplit(separator, limit) {
        return separator === undefined && limit === 0 ? [] : $split.call(this, separator, limit);
      };
    } else {
      internalSplit = $split;
    }

    return [// `String.prototype.split` method
    // https://tc39.github.io/ecma262/#sec-string.prototype.split
    function split(separator, limit) {
      var O = defined(this);
      var splitter = separator == undefined ? undefined : separator[SPLIT];
      return splitter !== undefined ? splitter.call(separator, O, limit) : internalSplit.call(String(O), separator, limit);
    }, // `RegExp.prototype[@@split]` method
    // https://tc39.github.io/ecma262/#sec-regexp.prototype-@@split
    //
    // NOTE: This cannot be properly polyfilled in engines that don't support
    // the 'y' flag.
    function (regexp, limit) {
      var res = maybeCallNative(internalSplit, regexp, this, limit, internalSplit !== $split);
      if (res.done) return res.value;
      var rx = _anObject(regexp);
      var S = String(this);
      var C = _speciesConstructor(rx, RegExp);
      var unicodeMatching = rx.unicode;
      var flags = (rx.ignoreCase ? 'i' : '') + (rx.multiline ? 'm' : '') + (rx.unicode ? 'u' : '') + (SUPPORTS_Y ? 'y' : 'g'); // ^(? + rx + ) is needed, in combination with some S slicing, to
      // simulate the 'y' flag.

      var splitter = new C(SUPPORTS_Y ? rx : '^(?:' + rx.source + ')', flags);
      var lim = limit === undefined ? 0xffffffff : limit >>> 0;
      if (lim === 0) return [];
      if (S.length === 0) return _regexpExecAbstract(splitter, S) === null ? [S] : [];
      var p = 0;
      var q = 0;
      var A = [];

      while (q < S.length) {
        splitter.lastIndex = SUPPORTS_Y ? q : 0;
        var z = _regexpExecAbstract(splitter, SUPPORTS_Y ? S : S.slice(q));
        var e;

        if (z === null || (e = $min(_toLength(splitter.lastIndex + (SUPPORTS_Y ? 0 : q)), S.length)) === p) {
          q = _advanceStringIndex(S, q, unicodeMatching);
        } else {
          A.push(S.slice(p, q));
          if (A.length === lim) return A;

          for (var i = 1; i <= z.length - 1; i++) {
            A.push(z[i]);
            if (A.length === lim) return A;
          }

          q = p = e;
        }
      }

      A.push(S.slice(p));
      return A;
    }];
  });

  _fixReWks('match', 1, function (defined, MATCH, $match, maybeCallNative) {
    return [// `String.prototype.match` method
    // https://tc39.github.io/ecma262/#sec-string.prototype.match
    function match(regexp) {
      var O = defined(this);
      var fn = regexp == undefined ? undefined : regexp[MATCH];
      return fn !== undefined ? fn.call(regexp, O) : new RegExp(regexp)[MATCH](String(O));
    }, // `RegExp.prototype[@@match]` method
    // https://tc39.github.io/ecma262/#sec-regexp.prototype-@@match
    function (regexp) {
      var res = maybeCallNative($match, regexp, this);
      if (res.done) return res.value;
      var rx = _anObject(regexp);
      var S = String(this);
      if (!rx.global) return _regexpExecAbstract(rx, S);
      var fullUnicode = rx.unicode;
      rx.lastIndex = 0;
      var A = [];
      var n = 0;
      var result;

      while ((result = _regexpExecAbstract(rx, S)) !== null) {
        var matchStr = String(result[0]);
        A[n] = matchStr;
        if (matchStr === '') rx.lastIndex = _advanceStringIndex(S, _toLength(rx.lastIndex), fullUnicode);
        n++;
      }

      return n === 0 ? null : A;
    }];
  });

  function _arrayWithHoles$1(arr) {
    if (Array.isArray(arr)) return arr;
  }

  var arrayWithHoles = _arrayWithHoles$1;

  function _iterableToArrayLimit$1(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  var iterableToArrayLimit = _iterableToArrayLimit$1;

  function _nonIterableRest$1() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
  }

  var nonIterableRest = _nonIterableRest$1;

  function _slicedToArray$1(arr, i) {
    return arrayWithHoles(arr) || iterableToArrayLimit(arr, i) || nonIterableRest();
  }

  var slicedToArray = _slicedToArray$1;

  /**
   * Copyright (c) 2013-present, Facebook, Inc.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */

  var ReactPropTypesSecret = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';
  var ReactPropTypesSecret_1 = ReactPropTypesSecret;

  function emptyFunction() {}

  function emptyFunctionWithReset() {}

  emptyFunctionWithReset.resetWarningCache = emptyFunction;

  var factoryWithThrowingShims = function factoryWithThrowingShims() {
    function shim(props, propName, componentName, location, propFullName, secret) {
      if (secret === ReactPropTypesSecret_1) {
        // It is still safe when called from React.
        return;
      }

      var err = new Error('Calling PropTypes validators directly is not supported by the `prop-types` package. ' + 'Use PropTypes.checkPropTypes() to call them. ' + 'Read more at http://fb.me/use-check-prop-types');
      err.name = 'Invariant Violation';
      throw err;
    }
    shim.isRequired = shim;

    function getShim() {
      return shim;
    }
    // Keep this list in sync with production version in `./factoryWithTypeCheckers.js`.

    var ReactPropTypes = {
      array: shim,
      bool: shim,
      func: shim,
      number: shim,
      object: shim,
      string: shim,
      symbol: shim,
      any: shim,
      arrayOf: getShim,
      element: shim,
      elementType: shim,
      instanceOf: getShim,
      node: shim,
      objectOf: getShim,
      oneOf: getShim,
      oneOfType: getShim,
      shape: getShim,
      exact: getShim,
      checkPropTypes: emptyFunctionWithReset,
      resetWarningCache: emptyFunction
    };
    ReactPropTypes.PropTypes = ReactPropTypes;
    return ReactPropTypes;
  };

  var propTypes = createCommonjsModule(function (module) {
    /**
     * Copyright (c) 2013-present, Facebook, Inc.
     *
     * This source code is licensed under the MIT license found in the
     * LICENSE file in the root directory of this source tree.
     */
    {
      // By explicitly using `prop-types` you are opting into new production behavior.
      // http://fb.me/prop-types-in-prod
      module.exports = factoryWithThrowingShims();
    }
  });

  var _ref = typeof window !== 'undefined' && window.navigator.userAgent.match(/Android[\s-/]([\d.]+)/i) || [],
      _ref2 = slicedToArray(_ref, 2),
      _ref2$ = _ref2[1],
      version = _ref2$ === void 0 ? '' : _ref2$;

  function Loading(_ref3) {
    var size = _ref3.size,
        dash = _ref3.dash,
        force = _ref3.force;
    var radius = (size - dash) / 2;

    if (force || +version.split('.')[0] < 5) {
      return React__default.createElement("div", {
        className: "lls-ui-loading__gd"
      });
    } else {
      return React__default.createElement("div", {
        className: "lls-ui-loading"
      }, React__default.createElement("svg", {
        viewBox: "0 0 ".concat(size, " ").concat(size)
      }, React__default.createElement("circle", {
        cx: size / 2,
        cy: size / 2,
        r: radius,
        fill: "none",
        strokeWidth: dash
      })));
    }
  }
  Loading.propTypes = {
    size: propTypes.number,
    dash: propTypes.number,
    force: propTypes.bool
  };
  Loading.defaultProps = {
    size: 36,
    dash: 4,
    force: false
    /**
     * size, dash目前虽然可以传递，但无法生效（样式层面）
     * 可以引入styled-components等css in js方案解决
     */

  };

  var LoadingComponent = function LoadingComponent(props) {
    var force = props.force,
        isPad = props.isPad,
        text = props.text;
    return React.createElement("div", {
      className: classnames('ph-loading', {
        'is-pad': isPad,
        'info-loading': text
      })
    }, React.createElement("div", {
      className: "loading-wrapper"
    }, React.createElement(Loading, {
      force: force
    }), text && React.createElement("p", {
      className: "loading-text"
    }, text)));
  };

  var index = new (
  /*#__PURE__*/
  function () {
    function Loading() {
      _classCallCheck(this, Loading);

      this.loadingEl = null;
      this.counter = 0;
    }

    _createClass(Loading, [{
      key: "clear",
      value: function clear() {
        var loadingEl = this.loadingEl;

        if (loadingEl) {
          this.loadingEl = null;
          document.body.removeChild(loadingEl);
          this.counter = 0;
        }
      }
    }, {
      key: "show",
      value: function show(text, force) {
        var isPad = getIsPadDisplay();

        if (this.counter <= 0) {
          this.loadingEl = this.addNode(React.createElement(LoadingComponent, {
            isPad: isPad,
            force: force,
            text: text
          }));
        }

        this.counter++;
      }
    }, {
      key: "hide",
      value: function hide() {
        var loadingEl = this.loadingEl,
            counter = this.counter;

        if (loadingEl && counter <= 1) {
          document.body.removeChild(loadingEl);
          this.loadingEl = null;
        }

        if (counter > 0) this.counter--;
      }
    }, {
      key: "addNode",
      value: function addNode(element) {
        var div = document.createElement('div');
        document.body.appendChild(div);
        ReactDOM.render(element, div);
        return div;
      }
    }]);

    return Loading;
  }())();

  var _extends_1 = createCommonjsModule(function (module) {
    function _extends() {
      module.exports = _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];

          for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }

        return target;
      };

      return _extends.apply(this, arguments);
    }

    module.exports = _extends;
  });

  function _classCallCheck$1(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var classCallCheck = _classCallCheck$1;

  function _defineProperties$1(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass$1(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties$1(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties$1(Constructor, staticProps);
    return Constructor;
  }

  var createClass = _createClass$1;

  var _typeof_1 = createCommonjsModule(function (module) {
    function _typeof2(obj) {
      if (typeof Symbol === "function" && _typeof(Symbol.iterator) === "symbol") {
        _typeof2 = function _typeof2(obj) {
          return _typeof(obj);
        };
      } else {
        _typeof2 = function _typeof2(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : _typeof(obj);
        };
      }

      return _typeof2(obj);
    }

    function _typeof$1(obj) {
      if (typeof Symbol === "function" && _typeof2(Symbol.iterator) === "symbol") {
        module.exports = _typeof$1 = function _typeof(obj) {
          return _typeof2(obj);
        };
      } else {
        module.exports = _typeof$1 = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : _typeof2(obj);
        };
      }

      return _typeof$1(obj);
    }

    module.exports = _typeof$1;
  });

  function _assertThisInitialized$1(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  var assertThisInitialized = _assertThisInitialized$1;

  function _possibleConstructorReturn$1(self, call) {
    if (call && (_typeof_1(call) === "object" || typeof call === "function")) {
      return call;
    }

    return assertThisInitialized(self);
  }

  var possibleConstructorReturn = _possibleConstructorReturn$1;

  var getPrototypeOf = createCommonjsModule(function (module) {
    function _getPrototypeOf(o) {
      module.exports = _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };
      return _getPrototypeOf(o);
    }

    module.exports = _getPrototypeOf;
  });

  var setPrototypeOf = createCommonjsModule(function (module) {
    function _setPrototypeOf(o, p) {
      module.exports = _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
        o.__proto__ = p;
        return o;
      };

      return _setPrototypeOf(o, p);
    }

    module.exports = _setPrototypeOf;
  });

  function _inherits$1(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) setPrototypeOf(subClass, superClass);
  }

  var inherits = _inherits$1;

  function _defineProperty$1(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  var defineProperty = _defineProperty$1;

  function _objectWithoutPropertiesLoose$1(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }

  var objectWithoutPropertiesLoose = _objectWithoutPropertiesLoose$1;

  function _objectWithoutProperties$1(source, excluded) {
    if (source == null) return {};
    var target = objectWithoutPropertiesLoose(source, excluded);
    var key, i;

    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }

    return target;
  }

  var objectWithoutProperties = _objectWithoutProperties$1;

  var AlertCircle = function AlertCircle(props) {
    var color = props.color,
        size = props.size,
        otherProps = objectWithoutProperties(props, ["color", "size"]);

    return React__default.createElement("svg", _extends_1({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: color,
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round"
    }, otherProps), React__default.createElement("circle", {
      cx: "12",
      cy: "12",
      r: "10"
    }), React__default.createElement("line", {
      x1: "12",
      y1: "8",
      x2: "12",
      y2: "12"
    }), React__default.createElement("line", {
      x1: "12",
      y1: "16",
      x2: "12",
      y2: "16"
    }));
  };

  AlertCircle.propTypes = {
    color: propTypes.string,
    size: propTypes.oneOfType([propTypes.string, propTypes.number])
  };
  AlertCircle.defaultProps = {
    color: 'currentColor',
    size: '24'
  };

  var ArrowDown = function ArrowDown(props) {
    var color = props.color,
        size = props.size,
        otherProps = objectWithoutProperties(props, ["color", "size"]);

    return React__default.createElement("svg", _extends_1({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: color,
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round"
    }, otherProps), React__default.createElement("line", {
      x1: "12",
      y1: "5",
      x2: "12",
      y2: "19"
    }), React__default.createElement("polyline", {
      points: "19 12 12 19 5 12"
    }));
  };

  ArrowDown.propTypes = {
    color: propTypes.string,
    size: propTypes.oneOfType([propTypes.string, propTypes.number])
  };
  ArrowDown.defaultProps = {
    color: 'currentColor',
    size: '24'
  };

  var ArrowDownCircle = function ArrowDownCircle(props) {
    var color = props.color,
        size = props.size,
        otherProps = objectWithoutProperties(props, ["color", "size"]);

    return React__default.createElement("svg", _extends_1({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: color,
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round"
    }, otherProps), React__default.createElement("circle", {
      cx: "12",
      cy: "12",
      r: "10"
    }), React__default.createElement("polyline", {
      points: "8 12 12 16 16 12"
    }), React__default.createElement("line", {
      x1: "12",
      y1: "8",
      x2: "12",
      y2: "16"
    }));
  };

  ArrowDownCircle.propTypes = {
    color: propTypes.string,
    size: propTypes.oneOfType([propTypes.string, propTypes.number])
  };
  ArrowDownCircle.defaultProps = {
    color: 'currentColor',
    size: '24'
  };

  var ArrowLeft = function ArrowLeft(props) {
    var color = props.color,
        size = props.size,
        otherProps = objectWithoutProperties(props, ["color", "size"]);

    return React__default.createElement("svg", _extends_1({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: color,
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round"
    }, otherProps), React__default.createElement("line", {
      x1: "19",
      y1: "12",
      x2: "5",
      y2: "12"
    }), React__default.createElement("polyline", {
      points: "12 19 5 12 12 5"
    }));
  };

  ArrowLeft.propTypes = {
    color: propTypes.string,
    size: propTypes.oneOfType([propTypes.string, propTypes.number])
  };
  ArrowLeft.defaultProps = {
    color: 'currentColor',
    size: '24'
  };

  var ArrowLeftCircle = function ArrowLeftCircle(props) {
    var color = props.color,
        size = props.size,
        otherProps = objectWithoutProperties(props, ["color", "size"]);

    return React__default.createElement("svg", _extends_1({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: color,
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round"
    }, otherProps), React__default.createElement("circle", {
      cx: "12",
      cy: "12",
      r: "10"
    }), React__default.createElement("polyline", {
      points: "12 8 8 12 12 16"
    }), React__default.createElement("line", {
      x1: "16",
      y1: "12",
      x2: "8",
      y2: "12"
    }));
  };

  ArrowLeftCircle.propTypes = {
    color: propTypes.string,
    size: propTypes.oneOfType([propTypes.string, propTypes.number])
  };
  ArrowLeftCircle.defaultProps = {
    color: 'currentColor',
    size: '24'
  };

  var ArrowRight = function ArrowRight(props) {
    var color = props.color,
        size = props.size,
        otherProps = objectWithoutProperties(props, ["color", "size"]);

    return React__default.createElement("svg", _extends_1({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: color,
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round"
    }, otherProps), React__default.createElement("line", {
      x1: "5",
      y1: "12",
      x2: "19",
      y2: "12"
    }), React__default.createElement("polyline", {
      points: "12 5 19 12 12 19"
    }));
  };

  ArrowRight.propTypes = {
    color: propTypes.string,
    size: propTypes.oneOfType([propTypes.string, propTypes.number])
  };
  ArrowRight.defaultProps = {
    color: 'currentColor',
    size: '24'
  };

  var ArrowRightCircle = function ArrowRightCircle(props) {
    var color = props.color,
        size = props.size,
        otherProps = objectWithoutProperties(props, ["color", "size"]);

    return React__default.createElement("svg", _extends_1({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: color,
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round"
    }, otherProps), React__default.createElement("circle", {
      cx: "12",
      cy: "12",
      r: "10"
    }), React__default.createElement("polyline", {
      points: "12 16 16 12 12 8"
    }), React__default.createElement("line", {
      x1: "8",
      y1: "12",
      x2: "16",
      y2: "12"
    }));
  };

  ArrowRightCircle.propTypes = {
    color: propTypes.string,
    size: propTypes.oneOfType([propTypes.string, propTypes.number])
  };
  ArrowRightCircle.defaultProps = {
    color: 'currentColor',
    size: '24'
  };

  var ArrowUp = function ArrowUp(props) {
    var color = props.color,
        size = props.size,
        otherProps = objectWithoutProperties(props, ["color", "size"]);

    return React__default.createElement("svg", _extends_1({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: color,
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round"
    }, otherProps), React__default.createElement("line", {
      x1: "12",
      y1: "19",
      x2: "12",
      y2: "5"
    }), React__default.createElement("polyline", {
      points: "5 12 12 5 19 12"
    }));
  };

  ArrowUp.propTypes = {
    color: propTypes.string,
    size: propTypes.oneOfType([propTypes.string, propTypes.number])
  };
  ArrowUp.defaultProps = {
    color: 'currentColor',
    size: '24'
  };

  var ArrowUpCircle = function ArrowUpCircle(props) {
    var color = props.color,
        size = props.size,
        otherProps = objectWithoutProperties(props, ["color", "size"]);

    return React__default.createElement("svg", _extends_1({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: color,
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round"
    }, otherProps), React__default.createElement("circle", {
      cx: "12",
      cy: "12",
      r: "10"
    }), React__default.createElement("polyline", {
      points: "16 12 12 8 8 12"
    }), React__default.createElement("line", {
      x1: "12",
      y1: "16",
      x2: "12",
      y2: "8"
    }));
  };

  ArrowUpCircle.propTypes = {
    color: propTypes.string,
    size: propTypes.oneOfType([propTypes.string, propTypes.number])
  };
  ArrowUpCircle.defaultProps = {
    color: 'currentColor',
    size: '24'
  };

  var ChevronDown = function ChevronDown(props) {
    var color = props.color,
        size = props.size,
        otherProps = objectWithoutProperties(props, ["color", "size"]);

    return React__default.createElement("svg", _extends_1({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: color,
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round"
    }, otherProps), React__default.createElement("polyline", {
      points: "6 9 12 15 18 9"
    }));
  };

  ChevronDown.propTypes = {
    color: propTypes.string,
    size: propTypes.oneOfType([propTypes.string, propTypes.number])
  };
  ChevronDown.defaultProps = {
    color: 'currentColor',
    size: '24'
  };

  var ChevronLeft = function ChevronLeft(props) {
    var color = props.color,
        size = props.size,
        otherProps = objectWithoutProperties(props, ["color", "size"]);

    return React__default.createElement("svg", _extends_1({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: color,
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round"
    }, otherProps), React__default.createElement("polyline", {
      points: "15 18 9 12 15 6"
    }));
  };

  ChevronLeft.propTypes = {
    color: propTypes.string,
    size: propTypes.oneOfType([propTypes.string, propTypes.number])
  };
  ChevronLeft.defaultProps = {
    color: 'currentColor',
    size: '24'
  };

  var ChevronRight = function ChevronRight(props) {
    var color = props.color,
        size = props.size,
        otherProps = objectWithoutProperties(props, ["color", "size"]);

    return React__default.createElement("svg", _extends_1({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: color,
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round"
    }, otherProps), React__default.createElement("polyline", {
      points: "9 18 15 12 9 6"
    }));
  };

  ChevronRight.propTypes = {
    color: propTypes.string,
    size: propTypes.oneOfType([propTypes.string, propTypes.number])
  };
  ChevronRight.defaultProps = {
    color: 'currentColor',
    size: '24'
  };

  var ChevronUp = function ChevronUp(props) {
    var color = props.color,
        size = props.size,
        otherProps = objectWithoutProperties(props, ["color", "size"]);

    return React__default.createElement("svg", _extends_1({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: color,
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round"
    }, otherProps), React__default.createElement("polyline", {
      points: "18 15 12 9 6 15"
    }));
  };

  ChevronUp.propTypes = {
    color: propTypes.string,
    size: propTypes.oneOfType([propTypes.string, propTypes.number])
  };
  ChevronUp.defaultProps = {
    color: 'currentColor',
    size: '24'
  };

  var Circle = function Circle(props) {
    var color = props.color,
        size = props.size,
        otherProps = objectWithoutProperties(props, ["color", "size"]);

    return React__default.createElement("svg", _extends_1({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: color,
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round"
    }, otherProps), React__default.createElement("circle", {
      cx: "12",
      cy: "12",
      r: "10"
    }));
  };

  Circle.propTypes = {
    color: propTypes.string,
    size: propTypes.oneOfType([propTypes.string, propTypes.number])
  };
  Circle.defaultProps = {
    color: 'currentColor',
    size: '24'
  };

  var HelpCircle = function HelpCircle(props) {
    var color = props.color,
        size = props.size,
        otherProps = objectWithoutProperties(props, ["color", "size"]);

    return React__default.createElement("svg", _extends_1({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: color,
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round"
    }, otherProps), React__default.createElement("path", {
      d: "M9.09 9a3 3 0 0 1 5.83 1c0 2-3 3-3 3"
    }), React__default.createElement("circle", {
      cx: "12",
      cy: "12",
      r: "10"
    }), React__default.createElement("line", {
      x1: "12",
      y1: "17",
      x2: "12",
      y2: "17"
    }));
  };

  HelpCircle.propTypes = {
    color: propTypes.string,
    size: propTypes.oneOfType([propTypes.string, propTypes.number])
  };
  HelpCircle.defaultProps = {
    color: 'currentColor',
    size: '24'
  };

  var Info = function Info(props) {
    var color = props.color,
        size = props.size,
        otherProps = objectWithoutProperties(props, ["color", "size"]);

    return React__default.createElement("svg", _extends_1({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: color,
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round"
    }, otherProps), React__default.createElement("circle", {
      cx: "12",
      cy: "12",
      r: "10"
    }), React__default.createElement("line", {
      x1: "12",
      y1: "16",
      x2: "12",
      y2: "12"
    }), React__default.createElement("line", {
      x1: "12",
      y1: "8",
      x2: "12",
      y2: "8"
    }));
  };

  Info.propTypes = {
    color: propTypes.string,
    size: propTypes.oneOfType([propTypes.string, propTypes.number])
  };
  Info.defaultProps = {
    color: 'currentColor',
    size: '24'
  };

  var Loader = function Loader(props) {
    var color = props.color,
        size = props.size,
        otherProps = objectWithoutProperties(props, ["color", "size"]);

    return React__default.createElement("svg", _extends_1({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: color,
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round"
    }, otherProps), React__default.createElement("line", {
      x1: "12",
      y1: "2",
      x2: "12",
      y2: "6"
    }), React__default.createElement("line", {
      x1: "12",
      y1: "18",
      x2: "12",
      y2: "22"
    }), React__default.createElement("line", {
      x1: "4.93",
      y1: "4.93",
      x2: "7.76",
      y2: "7.76"
    }), React__default.createElement("line", {
      x1: "16.24",
      y1: "16.24",
      x2: "19.07",
      y2: "19.07"
    }), React__default.createElement("line", {
      x1: "2",
      y1: "12",
      x2: "6",
      y2: "12"
    }), React__default.createElement("line", {
      x1: "18",
      y1: "12",
      x2: "22",
      y2: "12"
    }), React__default.createElement("line", {
      x1: "4.93",
      y1: "19.07",
      x2: "7.76",
      y2: "16.24"
    }), React__default.createElement("line", {
      x1: "16.24",
      y1: "7.76",
      x2: "19.07",
      y2: "4.93"
    }));
  };

  Loader.propTypes = {
    color: propTypes.string,
    size: propTypes.oneOfType([propTypes.string, propTypes.number])
  };
  Loader.defaultProps = {
    color: 'currentColor',
    size: '24'
  };

  var Search = function Search(props) {
    var color = props.color,
        size = props.size,
        otherProps = objectWithoutProperties(props, ["color", "size"]);

    return React__default.createElement("svg", _extends_1({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: color,
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round"
    }, otherProps), React__default.createElement("circle", {
      cx: "11",
      cy: "11",
      r: "8"
    }), React__default.createElement("line", {
      x1: "21",
      y1: "21",
      x2: "16.65",
      y2: "16.65"
    }));
  };

  Search.propTypes = {
    color: propTypes.string,
    size: propTypes.oneOfType([propTypes.string, propTypes.number])
  };
  Search.defaultProps = {
    color: 'currentColor',
    size: '24'
  };

  var Settings = function Settings(props) {
    var color = props.color,
        size = props.size,
        otherProps = objectWithoutProperties(props, ["color", "size"]);

    return React__default.createElement("svg", _extends_1({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: color,
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round"
    }, otherProps), React__default.createElement("circle", {
      cx: "12",
      cy: "12",
      r: "3"
    }), React__default.createElement("path", {
      d: "M19.4 15a1.65 1.65 0 0 0 .33 1.82l.06.06a2 2 0 0 1 0 2.83 2 2 0 0 1-2.83 0l-.06-.06a1.65 1.65 0 0 0-1.82-.33 1.65 1.65 0 0 0-1 1.51V21a2 2 0 0 1-2 2 2 2 0 0 1-2-2v-.09A1.65 1.65 0 0 0 9 19.4a1.65 1.65 0 0 0-1.82.33l-.06.06a2 2 0 0 1-2.83 0 2 2 0 0 1 0-2.83l.06-.06a1.65 1.65 0 0 0 .33-1.82 1.65 1.65 0 0 0-1.51-1H3a2 2 0 0 1-2-2 2 2 0 0 1 2-2h.09A1.65 1.65 0 0 0 4.6 9a1.65 1.65 0 0 0-.33-1.82l-.06-.06a2 2 0 0 1 0-2.83 2 2 0 0 1 2.83 0l.06.06a1.65 1.65 0 0 0 1.82.33H9a1.65 1.65 0 0 0 1-1.51V3a2 2 0 0 1 2-2 2 2 0 0 1 2 2v.09a1.65 1.65 0 0 0 1 1.51 1.65 1.65 0 0 0 1.82-.33l.06-.06a2 2 0 0 1 2.83 0 2 2 0 0 1 0 2.83l-.06.06a1.65 1.65 0 0 0-.33 1.82V9a1.65 1.65 0 0 0 1.51 1H21a2 2 0 0 1 2 2 2 2 0 0 1-2 2h-.09a1.65 1.65 0 0 0-1.51 1z"
    }));
  };

  Settings.propTypes = {
    color: propTypes.string,
    size: propTypes.oneOfType([propTypes.string, propTypes.number])
  };
  Settings.defaultProps = {
    color: 'currentColor',
    size: '24'
  };

  var X = function X(props) {
    var color = props.color,
        size = props.size,
        otherProps = objectWithoutProperties(props, ["color", "size"]);

    return React__default.createElement("svg", _extends_1({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: color,
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round"
    }, otherProps), React__default.createElement("line", {
      x1: "18",
      y1: "6",
      x2: "6",
      y2: "18"
    }), React__default.createElement("line", {
      x1: "6",
      y1: "6",
      x2: "18",
      y2: "18"
    }));
  };

  X.propTypes = {
    color: propTypes.string,
    size: propTypes.oneOfType([propTypes.string, propTypes.number])
  };
  X.defaultProps = {
    color: 'currentColor',
    size: '24'
  };

  var XCircle = function XCircle(props) {
    var color = props.color,
        size = props.size,
        otherProps = objectWithoutProperties(props, ["color", "size"]);

    return React__default.createElement("svg", _extends_1({
      xmlns: "http://www.w3.org/2000/svg",
      width: size,
      height: size,
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: color,
      strokeWidth: "2",
      strokeLinecap: "round",
      strokeLinejoin: "round"
    }, otherProps), React__default.createElement("circle", {
      cx: "12",
      cy: "12",
      r: "10"
    }), React__default.createElement("line", {
      x1: "15",
      y1: "9",
      x2: "9",
      y2: "15"
    }), React__default.createElement("line", {
      x1: "9",
      y1: "9",
      x2: "15",
      y2: "15"
    }));
  };

  XCircle.propTypes = {
    color: propTypes.string,
    size: propTypes.oneOfType([propTypes.string, propTypes.number])
  };
  XCircle.defaultProps = {
    color: 'currentColor',
    size: '24'
  };



  var Icons = /*#__PURE__*/Object.freeze({
    AlertCircle: AlertCircle,
    ArrowDown: ArrowDown,
    ArrowDownCircle: ArrowDownCircle,
    ArrowLeft: ArrowLeft,
    ArrowLeftCircle: ArrowLeftCircle,
    ArrowRight: ArrowRight,
    ArrowRightCircle: ArrowRightCircle,
    ArrowUp: ArrowUp,
    ArrowUpCircle: ArrowUpCircle,
    ChevronDown: ChevronDown,
    ChevronLeft: ChevronLeft,
    ChevronRight: ChevronRight,
    ChevronUp: ChevronUp,
    Circle: Circle,
    HelpCircle: HelpCircle,
    Info: Info,
    Loader: Loader,
    Search: Search,
    Settings: Settings,
    X: X,
    XCircle: XCircle
  });

  var _toObject = function _toObject(it) {
    return Object(_defined(it));
  };

  var max = Math.max;
  var min$1 = Math.min;
  var floor$1 = Math.floor;
  var SUBSTITUTION_SYMBOLS = /\$([$&`']|\d\d?|<[^>]*>)/g;
  var SUBSTITUTION_SYMBOLS_NO_NAMED = /\$([$&`']|\d\d?)/g;

  var maybeToString = function maybeToString(it) {
    return it === undefined ? it : String(it);
  }; // @@replace logic


  _fixReWks('replace', 2, function (defined, REPLACE, $replace, maybeCallNative) {
    return [// `String.prototype.replace` method
    // https://tc39.github.io/ecma262/#sec-string.prototype.replace
    function replace(searchValue, replaceValue) {
      var O = defined(this);
      var fn = searchValue == undefined ? undefined : searchValue[REPLACE];
      return fn !== undefined ? fn.call(searchValue, O, replaceValue) : $replace.call(String(O), searchValue, replaceValue);
    }, // `RegExp.prototype[@@replace]` method
    // https://tc39.github.io/ecma262/#sec-regexp.prototype-@@replace
    function (regexp, replaceValue) {
      var res = maybeCallNative($replace, regexp, this, replaceValue);
      if (res.done) return res.value;
      var rx = _anObject(regexp);
      var S = String(this);
      var functionalReplace = typeof replaceValue === 'function';
      if (!functionalReplace) replaceValue = String(replaceValue);
      var global = rx.global;

      if (global) {
        var fullUnicode = rx.unicode;
        rx.lastIndex = 0;
      }

      var results = [];

      while (true) {
        var result = _regexpExecAbstract(rx, S);
        if (result === null) break;
        results.push(result);
        if (!global) break;
        var matchStr = String(result[0]);
        if (matchStr === '') rx.lastIndex = _advanceStringIndex(S, _toLength(rx.lastIndex), fullUnicode);
      }

      var accumulatedResult = '';
      var nextSourcePosition = 0;

      for (var i = 0; i < results.length; i++) {
        result = results[i];
        var matched = String(result[0]);
        var position = max(min$1(_toInteger(result.index), S.length), 0);
        var captures = []; // NOTE: This is equivalent to
        //   captures = result.slice(1).map(maybeToString)
        // but for some reason `nativeSlice.call(result, 1, result.length)` (called in
        // the slice polyfill when slicing native arrays) "doesn't work" in safari 9 and
        // causes a crash (https://pastebin.com/N21QzeQA) when trying to debug it.

        for (var j = 1; j < result.length; j++) {
          captures.push(maybeToString(result[j]));
        }

        var namedCaptures = result.groups;

        if (functionalReplace) {
          var replacerArgs = [matched].concat(captures, position, S);
          if (namedCaptures !== undefined) replacerArgs.push(namedCaptures);
          var replacement = String(replaceValue.apply(undefined, replacerArgs));
        } else {
          replacement = getSubstitution(matched, S, position, captures, namedCaptures, replaceValue);
        }

        if (position >= nextSourcePosition) {
          accumulatedResult += S.slice(nextSourcePosition, position) + replacement;
          nextSourcePosition = position + matched.length;
        }
      }

      return accumulatedResult + S.slice(nextSourcePosition);
    }]; // https://tc39.github.io/ecma262/#sec-getsubstitution

    function getSubstitution(matched, str, position, captures, namedCaptures, replacement) {
      var tailPos = position + matched.length;
      var m = captures.length;
      var symbols = SUBSTITUTION_SYMBOLS_NO_NAMED;

      if (namedCaptures !== undefined) {
        namedCaptures = _toObject(namedCaptures);
        symbols = SUBSTITUTION_SYMBOLS;
      }

      return $replace.call(replacement, symbols, function (match, ch) {
        var capture;

        switch (ch.charAt(0)) {
          case '$':
            return '$';

          case '&':
            return matched;

          case '`':
            return str.slice(0, position);

          case "'":
            return str.slice(tailPos);

          case '<':
            capture = namedCaptures[ch.slice(1, -1)];
            break;

          default:
            // \d\d?
            var n = +ch;
            if (n === 0) return match;

            if (n > m) {
              var f = floor$1(n / 10);
              if (f === 0) return match;
              if (f <= m) return captures[f - 1] === undefined ? ch.charAt(1) : captures[f - 1] + ch.charAt(1);
              return match;
            }

            capture = captures[n - 1];
        }

        return capture === undefined ? '' : capture;
      });
    }
  });

  var f$1 = {}.propertyIsEnumerable;
  var _objectPie = {
    f: f$1
  };

  // eslint-disable-next-line no-prototype-builtins

  var _iobject = Object('z').propertyIsEnumerable(0) ? Object : function (it) {
    return _cof(it) == 'String' ? it.split('') : Object(it);
  };

  var _toIobject = function _toIobject(it) {
    return _iobject(_defined(it));
  };

  var gOPD = Object.getOwnPropertyDescriptor;
  var f$2 = _descriptors ? gOPD : function getOwnPropertyDescriptor(O, P) {
    O = _toIobject(O);
    P = _toPrimitive(P, true);
    if (_ie8DomDefine) try {
      return gOPD(O, P);
    } catch (e) {
      /* empty */
    }
    if (_has(O, P)) return _propertyDesc(!_objectPie.f.call(O, P), O[P]);
  };
  var _objectGopd = {
    f: f$2
  };

  /* eslint-disable no-proto */

  var check = function check(O, proto) {
    _anObject(O);
    if (!_isObject(proto) && proto !== null) throw TypeError(proto + ": can't set as prototype!");
  };

  var _setProto = {
    set: Object.setPrototypeOf || ('__proto__' in {} ? // eslint-disable-line
    function (test, buggy, set) {
      try {
        set = _ctx(Function.call, _objectGopd.f(Object.prototype, '__proto__').set, 2);
        set(test, []);
        buggy = !(test instanceof Array);
      } catch (e) {
        buggy = true;
      }

      return function setPrototypeOf(O, proto) {
        check(O, proto);
        if (buggy) O.__proto__ = proto;else set(O, proto);
        return O;
      };
    }({}, false) : undefined),
    check: check
  };

  var setPrototypeOf$1 = _setProto.set;

  var _inheritIfRequired = function _inheritIfRequired(that, target, C) {
    var S = target.constructor;
    var P;

    if (S !== C && typeof S == 'function' && (P = S.prototype) !== C.prototype && _isObject(P) && setPrototypeOf$1) {
      setPrototypeOf$1(that, P);
    }

    return that;
  };

  var max$1 = Math.max;
  var min$2 = Math.min;

  var _toAbsoluteIndex = function _toAbsoluteIndex(index, length) {
    index = _toInteger(index);
    return index < 0 ? max$1(index + length, 0) : min$2(index, length);
  };

  // true  -> Array#includes

  var _arrayIncludes = function _arrayIncludes(IS_INCLUDES) {
    return function ($this, el, fromIndex) {
      var O = _toIobject($this);
      var length = _toLength(O.length);
      var index = _toAbsoluteIndex(fromIndex, length);
      var value; // Array#includes uses SameValueZero equality algorithm
      // eslint-disable-next-line no-self-compare

      if (IS_INCLUDES && el != el) while (length > index) {
        value = O[index++]; // eslint-disable-next-line no-self-compare

        if (value != value) return true; // Array#indexOf ignores holes, Array#includes - not
      } else for (; length > index; index++) {
        if (IS_INCLUDES || index in O) {
          if (O[index] === el) return IS_INCLUDES || index || 0;
        }
      }
      return !IS_INCLUDES && -1;
    };
  };

  var shared = _shared('keys');

  var _sharedKey = function _sharedKey(key) {
    return shared[key] || (shared[key] = _uid(key));
  };

  var arrayIndexOf = _arrayIncludes(false);
  var IE_PROTO = _sharedKey('IE_PROTO');

  var _objectKeysInternal = function _objectKeysInternal(object, names) {
    var O = _toIobject(object);
    var i = 0;
    var result = [];
    var key;

    for (key in O) {
      if (key != IE_PROTO) _has(O, key) && result.push(key);
    } // Don't enum bug & hidden keys


    while (names.length > i) {
      if (_has(O, key = names[i++])) {
        ~arrayIndexOf(result, key) || result.push(key);
      }
    }

    return result;
  };

  // IE 8- don't enum bug keys
  var _enumBugKeys = 'constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf'.split(',');

  var hiddenKeys = _enumBugKeys.concat('length', 'prototype');

  var f$3 = Object.getOwnPropertyNames || function getOwnPropertyNames(O) {
    return _objectKeysInternal(O, hiddenKeys);
  };

  var _objectGopn = {
    f: f$3
  };

  var SPECIES$2 = _wks('species');

  var _setSpecies = function _setSpecies(KEY) {
    var C = _global[KEY];
    if (_descriptors && C && !C[SPECIES$2]) _objectDp.f(C, SPECIES$2, {
      configurable: true,
      get: function get() {
        return this;
      }
    });
  };

  var dP$1 = _objectDp.f;
  var gOPN = _objectGopn.f;
  var $RegExp = _global.RegExp;
  var Base = $RegExp;
  var proto = $RegExp.prototype;
  var re1 = /a/g;
  var re2 = /a/g; // "new" creates a new object, old webkit buggy here

  var CORRECT_NEW = new $RegExp(re1) !== re1;

  if (_descriptors && (!CORRECT_NEW || _fails(function () {
    re2[_wks('match')] = false; // RegExp constructor can alter flags and IsRegExp works correct with @@match

    return $RegExp(re1) != re1 || $RegExp(re2) == re2 || $RegExp(re1, 'i') != '/a/i';
  }))) {
    $RegExp = function RegExp(p, f) {
      var tiRE = this instanceof $RegExp;
      var piRE = _isRegexp(p);
      var fiU = f === undefined;
      return !tiRE && piRE && p.constructor === $RegExp && fiU ? p : _inheritIfRequired(CORRECT_NEW ? new Base(piRE && !fiU ? p.source : p, f) : Base((piRE = p instanceof $RegExp) ? p.source : p, piRE && fiU ? _flags.call(p) : f), tiRE ? this : proto, $RegExp);
    };

    var proxy = function proxy(key) {
      key in $RegExp || dP$1($RegExp, key, {
        configurable: true,
        get: function get() {
          return Base[key];
        },
        set: function set(it) {
          Base[key] = it;
        }
      });
    };

    for (var keys = gOPN(Base), i = 0; keys.length > i;) {
      proxy(keys[i++]);
    }

    proto.constructor = $RegExp;
    $RegExp.prototype = proto;
    _redefine(_global, 'RegExp', $RegExp);
  }

  _setSpecies('RegExp');

  /** Used as references for various `Number` constants. */

  /** Detect free variable `global` from Node.js. */

  var freeGlobal = _typeof(commonjsGlobal) == 'object' && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;
  var _freeGlobal = freeGlobal;

  /** Detect free variable `self`. */

  var freeSelf = (typeof self === "undefined" ? "undefined" : _typeof(self)) == 'object' && self && self.Object === Object && self;
  /** Used as a reference to the global object. */

  var root = _freeGlobal || freeSelf || Function('return this')();
  var _root = root;

  /** Built-in value references. */

  var _Symbol2 = _root.Symbol;
  var _Symbol = _Symbol2;

  /**
   * A specialized version of `_.map` for arrays without support for iteratee
   * shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array} Returns the new mapped array.
   */

  /**
   * Checks if `value` is classified as an `Array` object.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an array, else `false`.
   * @example
   *
   * _.isArray([1, 2, 3]);
   * // => true
   *
   * _.isArray(document.body.children);
   * // => false
   *
   * _.isArray('abc');
   * // => false
   *
   * _.isArray(_.noop);
   * // => false
   */

  /** Built-in value references. */

  var symToStringTag = _Symbol ? _Symbol.toStringTag : undefined;

  /** Used for built-in method references. */

  /** Built-in value references. */

  var symToStringTag$1 = _Symbol ? _Symbol.toStringTag : undefined;

  /** Used to convert symbols to primitives and strings. */

  var symbolProto = _Symbol ? _Symbol.prototype : undefined,
      symbolToString = symbolProto ? symbolProto.toString : undefined;

  /**
   * The base implementation of `_.slice` without an iteratee call guard.
   *
   * @private
   * @param {Array} array The array to slice.
   * @param {number} [start=0] The start position.
   * @param {number} [end=array.length] The end position.
   * @returns {Array} Returns the slice of `array`.
   */

  /** Used to compose unicode character classes. */

  /**
   * The base implementation of `_.property` without support for deep paths.
   *
   * @private
   * @param {string} key The key of the property to get.
   * @returns {Function} Returns the new accessor function.
   */

  /** Used to compose unicode character classes. */

  /**
   * Converts an ASCII `string` to an array.
   *
   * @private
   * @param {string} string The string to convert.
   * @returns {Array} Returns the converted array.
   */

  /** Used to compose unicode character classes. */

  var isIOS$1 = /ip(ad|hone|od)/i.test(typeof window !== 'undefined' && window.navigator.userAgent);
  function capitalize(str) {
    var tmp = str.toLowerCase();
    return tmp.charAt(0).toUpperCase() + tmp.slice(1);
  }
  function noop$1() {}
  function getContainer() {
    var div = document.createElement('div');
    document.body.appendChild(div);
    return div;
  }

  function Icon(_ref) {
    var type = _ref.type,
        className = _ref.className,
        props = objectWithoutProperties(_ref, ["type", "className"]);

    var t = type.split('-').reduce(function (r, s) {
      return r + capitalize(s);
    }, '');
    var TheIcon = Icons[t];
    var cls = classnames(className, 'lls-ui-icon');

    if (TheIcon) {
      return React__default.createElement(TheIcon, _extends_1({}, props, {
        className: cls
      }));
    } else {
      return React__default.createElement("div", null, "unkonw type");
    }
  }
  Icon.propTypes = {
    type: propTypes.string.isRequired
  };

  var container;
  var instance;

  var Toast =
  /*#__PURE__*/
  function (_Component) {
    inherits(Toast, _Component);

    function Toast() {
      classCallCheck(this, Toast);

      return possibleConstructorReturn(this, getPrototypeOf(Toast).apply(this, arguments));
    }

    createClass(Toast, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        this.timeId = setTimeout(function () {
          ReactDOM.unmountComponentAtNode(container);
        }, this.props.duration);
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this.props.onClose();
        this.timeId && clearTimeout(this.timeId);
      }
    }, {
      key: "render",
      value: function render() {
        var _this$props = this.props,
            content = _this$props.content,
            type = _this$props.type;
        var icon = type === 'error' ? React__default.createElement(Icon, {
          type: "x",
          size: 32
        }) : null;
        return React__default.createElement("div", {
          className: "lls-ui-toast"
        }, React__default.createElement("div", {
          className: "lls-ui-toast-content"
        }, icon, React__default.createElement("p", null, content)));
      }
    }], [{
      key: "show",
      value: function show(content, duration, onClose, type) {
        var props = {
          content: content,
          duration: duration,
          onClose: onClose,
          type: type
        };

        if (!container) {
          container = getContainer();
        }

        if (instance) {
          ReactDOM.unmountComponentAtNode(container);
          instance = null;
        }

        ReactDOM.render(React__default.createElement(Toast, _extends_1({
          ref: function ref(i) {
            return instance = i;
          }
        }, props)), container);
      }
    }]);

    return Toast;
  }(React.Component);

  defineProperty(Toast, "propTypes", {
    content: propTypes.node,
    duration: propTypes.number,
    onClose: propTypes.func.isRequired,
    type: propTypes.string
  });

  defineProperty(Toast, "defaultProps", {
    content: null,
    duration: 2000,
    onClose: noop$1,
    type: 'info'
  });

  var Toast$1 = {
    info: function info(content, duration, onClose) {
      Toast.show(content, duration, onClose, 'info');
    },
    error: function error(content, duration, onClose) {
      Toast.show(content, duration, onClose, 'error');
    }
  };

  if (getIsPadDisplay()) {
    setTimeout(function () {
      document.body.classList.add('ph-pad-body');
    }, 0);
  }

  var PHONE_IMAGE$2 = [{
    375: 'https://cdn.llscdn.com/phonics-ui/phone-empty.png',
    750: 'https://cdn.llscdn.com/phonics-ui/phone-empty@2x.png',
    1125: 'https://cdn.llscdn.com/phonics-ui/phone-empty@3x.png',
    height: "".concat(168 / PHONE_RATIO, "rem")
  }];
  var PAD_IMAGE$2 = [{
    1024: 'https://cdn.llscdn.com/phonics-ui/pad-empty.png',
    2048: 'https://cdn.llscdn.com/phonics-ui/pad-empty@2x.png',
    3072: 'https://cdn.llscdn.com/phonics-ui/pad-empty@3x.png',
    height: "".concat(207 / PAD_RATIO, "rem")
  }];
  var DEFAULT_TEXT = '暂无数据';
  function EmptyRecord(props) {
    var isPad = props.isPad,
        className = props.className,
        text = props.text;
    var emptyText = text || parseParams().text || DEFAULT_TEXT;
    return React__default.createElement("div", {
      className: classnames('ph-empty-record', className, {
        'is-pad': isPad
      })
    }, React__default.createElement(Imager, {
      className: "empty-image",
      isPad: isPad,
      imgList: isPad ? PAD_IMAGE$2 : PHONE_IMAGE$2
    }), React__default.createElement("p", {
      className: "empty-text"
    }, emptyText));
  }

  var Img =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(Img, _React$Component);

    function Img() {
      var _this;

      _classCallCheck(this, Img);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(Img).apply(this, arguments));
      _this.touchTimer = null;
      _this.touchX = 0;
      _this.touchY = 0;

      _this.onTouchStart = function (e) {
        var _e$touches$ = e.touches[0],
            pageX = _e$touches$.pageX,
            pageY = _e$touches$.pageY;
        _this.touchX = pageX;
        _this.touchY = pageY;
        _this.touchTimer = Date.now();
      };

      _this.onTouchEnd = function (e) {
        var touchDuration = Date.now() - _this.touchTimer;

        var _e$changedTouches$ = e.changedTouches[0],
            pageX = _e$changedTouches$.pageX,
            pageY = _e$changedTouches$.pageY;
        var onLongTouch = _this.props.onLongTouch;

        var _assertThisInitialize = _assertThisInitialized(_this),
            touchX = _assertThisInitialize.touchX,
            touchY = _assertThisInitialize.touchY;

        var isMove = pageX - touchX > MAX_MOVE || touchX - pageX > MAX_MOVE || pageY - touchY > MAX_MOVE || touchY - pageY > MAX_MOVE;

        if (touchDuration > LONG_TOUCH_DURATION && onLongTouch && !isMove) {
          onLongTouch();
        }
      };

      return _this;
    }

    _createClass(Img, [{
      key: "render",
      value: function render() {
        var _this$props = this.props,
            className = _this$props.className,
            isPad = _this$props.isPad,
            onLongTouch = _this$props.onLongTouch,
            props = _objectWithoutProperties(_this$props, ["className", "isPad", "onLongTouch"]);

        return React.createElement("img", _extends({
          onTouchStart: this.onTouchStart,
          onTouchEnd: this.onTouchEnd,
          onTouchCancel: this.onTouchEnd,
          className: classnames('ph-img', className, {
            'is-pad': isPad
          })
        }, props));
      }
    }]);

    return Img;
  }(React.Component);

  var Cache = {};
  var SessionCache = {};

  function _getStore(key, isSession) {
    try {
      var storeType = isSession ? 'sessionStorage' : 'localStorage';
      return JSON.parse(window[storeType].getItem(key));
    } catch (e) {}
  }

  function _setStore(key, value, isSession) {
    try {
      var storeType = isSession ? 'sessionStorage' : 'localStorage';
      window[storeType].setItem(key, JSON.stringify(value));
    } catch (e) {}
  }

  function _removeStore(key, isSession) {
    try {
      var storeType = isSession ? 'sessionStorage' : 'localStorage';
      window[storeType].removeItem(key);
    } catch (e) {}
  }

  function _clearStore(isSession) {
    try {
      var storeType = isSession ? 'sessionStorage' : 'localStorage';
      window[storeType].clear();
    } catch (e) {}
  }

  function getStore(key) {
    return Cache[key] !== undefined ? Cache[key] : Cache[key] = _getStore(key);
  }
  function setStore(key, value) {
    if (Cache[key] === value) return;

    _setStore(key, value);

    Cache[key] = value;
  }
  function removeStore(key) {
    _removeStore(key);

    delete Cache[key];
  }
  function clearStore() {
    _clearStore();

    Cache = {};
  }
  function getSessionStore(key) {
    return SessionCache[key] !== undefined ? SessionCache[key] : SessionCache[key] = _getStore(key, true);
  }
  function setSessionStore(key, value) {
    if (SessionCache[key] === value) return;

    _setStore(key, value, true);

    SessionCache[key] = value;
  }
  function removeSessionStore(key) {
    _removeStore(key, true);

    delete SessionCache[key];
  }
  function clearSessionStore() {
    _clearStore(true);

    SessionCache = {};
  }
  var index$1 = {
    getStore: getStore,
    setStore: setStore,
    removeStore: removeStore,
    clearStore: clearStore,
    getSessionStore: getSessionStore,
    setSessionStore: setSessionStore,
    removeSessionStore: removeSessionStore,
    clearSessionStore: clearSessionStore
  };

  var Status;

  (function (Status) {
    Status[Status["PLAY"] = 0] = "PLAY";
    Status[Status["STOP"] = 1] = "STOP";
  })(Status || (Status = {}));

  var AudioHorn =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(AudioHorn, _React$Component);

    function AudioHorn() {
      var _this;

      _classCallCheck(this, AudioHorn);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(AudioHorn).apply(this, arguments));
      _this.audio = null;
      _this.state = {
        status: Status.STOP
      };

      _this.clickHandler = function () {
        var status = _this.state.status;
        var onClick = _this.props.onClick;
        var audio = _this.audio;

        if (status === Status.PLAY) {
          audio.pause();

          _this.setState({
            status: Status.STOP
          });
        } else {
          audio.currentTime = 0;
          audio.play();

          _this.setState({
            status: Status.PLAY
          });
        }

        if (onClick) onClick();
      };

      return _this;
    }

    _createClass(AudioHorn, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        var _this2 = this;

        setTimeout(function (_) {

          _this2.audio.addEventListener('ended', function () {
            _this2.setState({
              status: Status.STOP
            });
          });
        }, 0);
      }
    }, {
      key: "render",
      value: function render() {
        var _this3 = this;

        var _this$props = this.props,
            url = _this$props.url,
            isPad = _this$props.isPad,
            className = _this$props.className;
        return React__default.createElement("div", {
          className: classnames('ph-audio-horn', className, {
            'on-play': this.state.status === Status.PLAY,
            'is-pad': isPad
          }),
          onClick: this.clickHandler
        }, React__default.createElement("audio", {
          className: "audio-el",
          ref: function ref(el) {
            return _this3.audio = el;
          },
          src: url
        }));
      }
    }]);

    return AudioHorn;
  }(React__default.Component);

  var Status$1;

  (function (Status) {
    Status[Status["PLAY"] = 0] = "PLAY";
    Status[Status["STOP"] = 1] = "STOP";
  })(Status$1 || (Status$1 = {}));

  var AudioBlock =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(AudioBlock, _React$Component);

    function AudioBlock() {
      var _this;

      _classCallCheck(this, AudioBlock);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(AudioBlock).apply(this, arguments));
      _this.audio = null;
      _this.state = {
        status: Status$1.STOP
      };

      _this.clickHandler = function () {
        var status = _this.state.status;
        var onClick = _this.props.onClick;
        var audio = _this.audio;

        if (status === Status$1.PLAY) {
          audio.pause();

          _this.setState({
            status: Status$1.STOP
          });
        } else {
          audio.currentTime = 0;
          audio.play();

          _this.setState({
            status: Status$1.PLAY
          });
        }

        if (onClick) onClick();
      };

      return _this;
    }

    _createClass(AudioBlock, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        var _this2 = this;

        setTimeout(function (_) {

          _this2.audio.addEventListener('ended', function () {
            _this2.setState({
              status: Status$1.STOP
            });
          });
        }, 0);
      }
    }, {
      key: "render",
      value: function render() {
        var _this3 = this;

        var _this$props = this.props,
            url = _this$props.url,
            isPad = _this$props.isPad,
            className = _this$props.className,
            duration = _this$props.duration;
        return React__default.createElement("div", {
          className: classnames('ph-audio-block', className, {
            'on-play': this.state.status === Status$1.PLAY,
            'is-pad': isPad
          }),
          onClick: this.clickHandler
        }, React__default.createElement("div", {
          className: "animation-container"
        }, React__default.createElement("i", {
          className: "animation-item"
        }), React__default.createElement("i", {
          className: "animation-item"
        }), React__default.createElement("i", {
          className: "animation-item"
        }), React__default.createElement("i", {
          className: "animation-item"
        })), React__default.createElement("span", {
          className: "duration-text"
        }, duration !== undefined && "".concat(duration, "''")), React__default.createElement("audio", {
          className: "audio-el",
          ref: function ref(el) {
            return _this3.audio = el;
          },
          src: url
        }));
      }
    }]);

    return AudioBlock;
  }(React__default.Component);

  var ClickAnime =
  /*#__PURE__*/
  function (_PureComponent) {
    _inherits(ClickAnime, _PureComponent);

    function ClickAnime() {
      var _this;

      _classCallCheck(this, ClickAnime);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(ClickAnime).apply(this, arguments));
      _this.el = null;
      _this.state = {
        touchIn: false
      };

      _this.touchStart = function () {
        _this.setState({
          touchIn: true
        });
      };

      _this.touchEnd = function () {
        _this.setState({
          touchIn: false
        });
      };

      return _this;
    }

    _createClass(ClickAnime, [{
      key: "render",
      value: function render() {
        var _this2 = this;

        var _this$props = this.props,
            children = _this$props.children,
            className = _this$props.className,
            startTransform = _this$props.startTransform,
            endTransform = _this$props.endTransform,
            selected = _this$props.selected,
            _onClick = _this$props.onClick;
        return React__default.createElement("div", {
          className: classnames('ph-click-anime', className),
          style: {
            transform: this.state.touchIn || selected ? endTransform : startTransform
          },
          onClick: function onClick(e) {
            if (_onClick) _onClick(e);
          },
          ref: function ref(el) {
            return _this2.el = el;
          },
          onTouchStart: this.touchStart,
          onTouchEnd: this.touchEnd,
          onTouchCancel: this.touchEnd
        }, children);
      }
    }]);

    return ClickAnime;
  }(React.PureComponent);
  ClickAnime.defaultProps = {
    startTransform: 'scale(1)',
    endTransform: 'scale(1.08)',
    selected: false
  };

  var LongTouch =
  /*#__PURE__*/
  function (_PureComponent) {
    _inherits(LongTouch, _PureComponent);

    function LongTouch() {
      var _this;

      _classCallCheck(this, LongTouch);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(LongTouch).apply(this, arguments));
      _this.touchTimer = null;
      _this.touchX = 0;
      _this.touchY = 0;

      _this.onTouchStart = function (e) {
        var _e$touches$ = e.touches[0],
            pageX = _e$touches$.pageX,
            pageY = _e$touches$.pageY;
        _this.touchX = pageX;
        _this.touchY = pageY;
        _this.touchTimer = Date.now();
      };

      _this.onTouchEnd = function (e) {
        var touchDuration = Date.now() - _this.touchTimer;

        var _e$changedTouches$ = e.changedTouches[0],
            pageX = _e$changedTouches$.pageX,
            pageY = _e$changedTouches$.pageY;
        var onLongTouch = _this.props.onLongTouch;

        var _assertThisInitialize = _assertThisInitialized(_this),
            touchX = _assertThisInitialize.touchX,
            touchY = _assertThisInitialize.touchY;

        var isMove = pageX - touchX > MAX_MOVE || touchX - pageX > MAX_MOVE || pageY - touchY > MAX_MOVE || touchY - pageY > MAX_MOVE;

        if (touchDuration > LONG_TOUCH_DURATION && onLongTouch && !isMove) {
          onLongTouch();
        }
      };

      return _this;
    }

    _createClass(LongTouch, [{
      key: "render",
      value: function render() {
        return React__default.createElement("div", {
          onTouchStart: this.onTouchStart,
          onTouchEnd: this.onTouchEnd,
          onTouchCancel: this.onTouchEnd
        }, this.props.children);
      }
    }]);

    return LongTouch;
  }(React.PureComponent);

  function preload(imgList) {
    return function preloadHoc(OriginComponent) {
      return (
        /*#__PURE__*/
        function (_Component) {
          _inherits(PreloadWrapper, _Component);

          function PreloadWrapper() {
            _classCallCheck(this, PreloadWrapper);

            return _possibleConstructorReturn(this, _getPrototypeOf(PreloadWrapper).apply(this, arguments));
          }

          _createClass(PreloadWrapper, [{
            key: "componentWillMount",
            value: function componentWillMount() {
              preloadImage(imgList);
            }
          }, {
            key: "render",
            value: function render() {
              return React__default.createElement(OriginComponent, _extends({}, this.props));
            }
          }]);

          return PreloadWrapper;
        }(React.Component)
      );
    };
  }

  function getDPR$1() {
    var dpr = Math.floor(window.devicePixelRatio) || 1;
    if (dpr > 3) dpr = 3;
    if (dpr < 1) dpr = 1;
    return dpr;
  }

  var Picture =
  /*#__PURE__*/
  function (_PureComponent) {
    _inherits(Picture, _PureComponent);

    function Picture() {
      var _this;

      _classCallCheck(this, Picture);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(Picture).apply(this, arguments));
      _this.container = null;
      _this.dpr = getDPR$1();
      return _this;
    }

    _createClass(Picture, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        this.initImage();
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this.container = null;
      }
    }, {
      key: "initImage",
      value: function initImage() {
        var _this2 = this;

        var _this$props = this.props,
            img = _this$props.img,
            list = _this$props.list,
            onSuccess = _this$props.onSuccess,
            onFailure = _this$props.onFailure;
        var imgList = img ? [img] : list;
        var sequence = Promise.resolve();
        imgList.forEach(function (listItem, index) {
          sequence = sequence.then(function () {
            return _this2.createImage(listItem, index);
          });
        });
        sequence.then(onSuccess, onFailure);
      }
    }, {
      key: "createImage",
      value: function createImage(listItem, index) {
        var dpr = this.dpr,
            props = this.props,
            container = this.container;
        var onClick = props.onClick,
            useDivInner = props.useDivInner,
            pxToRem = props.pxToRem,
            isPad = props.isPad,
            superWidth = props.width,
            replace = props.replace;
        var itemWidth = listItem.width,
            height = listItem.height,
            divInner = listItem.divInner,
            src = listItem.src;
        var isDivInner = typeof divInner === 'undefined' ? useDivInner : divInner;
        var ratio = isPad ? PAD_RATIO : PHONE_RATIO;
        var heightString = pxToRem ? "".concat(height / ratio, "rem") : "".concat(height, "px");
        var width = itemWidth || superWidth;
        var widthString = width && pxToRem ? "".concat(width / ratio, "rem") : "".concat(width, "px");
        return new Promise(function (resolve, reject) {
          if (!container) return;
          var box = document.createElement('div');
          box.className = 'imager-container';
          box.style.height = heightString;
          if (widthString) box.style.width = widthString;
          container.appendChild(box);

          if (onClick) {
            box.addEventListener('click', function (event) {
              onClick(event, listItem, index);
            });
          }

          var nodeType = isDivInner ? 'div' : 'img';
          var imgEl = document.createElement(nodeType);
          imgEl.className = 'imager-inner';
          var resource = new Image();
          var miniImg = "".concat(src, "?imageView2/2/h/").concat(height);
          var suitableImg = dpr === 3 ? src : "".concat(src, "?imageView2/2/h/").concat(height * dpr);

          resource.onload = function () {
            box.style.backgroundImage = "url(".concat(miniImg, ")");
            var suitableImgLoader = replace ? loadImage(suitableImg) : Promise.resolve({});
            suitableImgLoader.then(function () {
              if (isDivInner) {
                imgEl.style.backgroundImage = "url(".concat(suitableImg, ")");
              } else {
                var el = imgEl;
                el.src = suitableImg;
                el.style.height = heightString;
                if (widthString) el.style.width = widthString;
              }

              if (box) box.appendChild(imgEl);
              if (replace) box.style.backgroundImage = '';
            });
            resolve();
          };

          resource.onerror = function (err) {
            reject(err);
          };

          resource.src = miniImg;
        });
      }
    }, {
      key: "render",
      value: function render() {
        var _this3 = this;

        var _this$props2 = this.props,
            className = _this$props2.className,
            isPad = _this$props2.isPad;
        return React__default.createElement("div", {
          ref: function ref(el) {
            return _this3.container = el;
          },
          className: classnames('ph-picture', className, {
            'is-pad': isPad
          })
        });
      }
    }]);

    return Picture;
  }(React.PureComponent);
  Picture.defaultProps = {
    pxToRem: true
  };

  var Subtitle =
  /*#__PURE__*/
  function (_PureComponent) {
    _inherits(Subtitle, _PureComponent);

    function Subtitle() {
      var _this;

      _classCallCheck(this, Subtitle);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(Subtitle).apply(this, arguments));
      _this.state = {
        transiting: false,
        currentIndex: 0
      };
      _this.timeoutToken = null;
      _this.intervalToekn = null;
      _this.el = null;
      _this.visible = true;

      _this.terminateCurrentTransition = function () {
        _this.setState({
          transiting: false,
          currentIndex: _this.getNextIndex()
        });

        _this.scheduleNextTransition();
      };

      return _this;
    }

    _createClass(Subtitle, [{
      key: "scheduleNextTransition",
      value: function scheduleNextTransition() {
        var _this2 = this;

        this.timeoutToken = setTimeout(function () {
          _this2.setState({
            transiting: true
          });
        }, this.props.duration);
      }
    }, {
      key: "componentDidMount",
      value: function componentDidMount() {
        var _this3 = this;

        if (this.props.watchVisible) {
          this.intervalToekn = setInterval(function () {
            var _this3$el$getBounding = _this3.el.getBoundingClientRect(),
                width = _this3$el$getBounding.width;

            if (width && !_this3.visible) {
              _this3.visible = true;

              _this3.terminateCurrentTransition();
            }

            if (!width && _this3.visible) {
              _this3.visible = false;
            }
          }, this.props.watchCheckDuration);
        }

        this.scheduleNextTransition();
      }
    }, {
      key: "getNextIndex",
      value: function getNextIndex() {
        var index = this.state.currentIndex;
        var nextIndex = index + 1;
        return nextIndex === this.props.textList.length ? 0 : nextIndex;
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        if (this.timeoutToken) clearTimeout(this.timeoutToken);
        if (this.props.watchVisible) clearInterval(this.intervalToekn);
      }
    }, {
      key: "render",
      value: function render() {
        var _this4 = this;

        var _this$props = this.props,
            rightText = _this$props.rightText,
            background = _this$props.background,
            textList = _this$props.textList,
            isPad = _this$props.isPad,
            className = _this$props.className;
        var _this$state = this.state,
            transiting = _this$state.transiting,
            currentIndex = _this$state.currentIndex;
        var num = rightText.num,
            text = rightText.text;
        var list = textList.slice(currentIndex, currentIndex + 2);
        if (list.length === 1) list.push(textList[0]);
        return React__default.createElement("div", {
          className: classnames('ph-subtitle', className, {
            'is-pad': isPad
          }),
          ref: function ref(el) {
            return _this4.el = el;
          },
          style: {
            background: background
          }
        }, React__default.createElement("div", {
          className: "main-container"
        }, React__default.createElement("div", {
          className: classnames('scroll-box', {
            transiting: transiting
          }),
          onTransitionEnd: this.terminateCurrentTransition
        }, list.map(function (_ref, index) {
          var name = _ref.name,
              text = _ref.text,
              gender = _ref.gender;
          return React__default.createElement("div", {
            key: index
          }, React__default.createElement("div", {
            className: "subtitle-column"
          }, React__default.createElement(Avatar, {
            gender: gender
          }), React__default.createElement("div", {
            className: "subtitle-name"
          }, name), React__default.createElement("div", {
            className: "subtitle-text"
          }, text)));
        }))), React__default.createElement("div", {
          className: "right-container"
        }, React__default.createElement("span", {
          className: "right-num"
        }, num), React__default.createElement("span", {
          className: "right-text"
        }, text)));
      }
    }]);

    return Subtitle;
  }(React.PureComponent);
  Subtitle.defaultProps = {
    background: '#9468D9',
    duration: 1000,
    watchCheckDuration: 100
  };

  var context = React__default.createContext({});

  var Confirm =
  /*#__PURE__*/
  function (_Component) {
    _inherits(Confirm, _Component);

    function Confirm() {
      _classCallCheck(this, Confirm);

      return _possibleConstructorReturn(this, _getPrototypeOf(Confirm).apply(this, arguments));
    }

    _createClass(Confirm, [{
      key: "render",
      value: function render() {
        return React__default.createElement(context.Consumer, null, function (_ref) {
          var cancelText = _ref.cancelText,
              confirmText = _ref.confirmText,
              onConfirmClick = _ref.onConfirmClick,
              onCancelClick = _ref.onCancelClick,
              content = _ref.content,
              children = _ref.children;
          return React__default.createElement("div", {
            className: "ph-dialog-confirm"
          }, React__default.createElement("div", {
            className: "ph-dialog-content"
          }, children ? children : content), React__default.createElement("div", {
            className: "ph-dialog-btn-area"
          }, React__default.createElement("div", {
            className: "ph-dialog-btn ph-dialog-cancelbtn",
            onClick: onCancelClick
          }, cancelText), React__default.createElement("div", {
            className: "ph-dialog-btn ph-dialog-confirmbtn",
            onClick: onConfirmClick
          }, confirmText)));
        });
      }
    }]);

    return Confirm;
  }(React.Component);

  Confirm.defaultProps = {
    onConfirmClick: function onConfirmClick() {},
    onCancelClick: function onCancelClick() {},
    cancelText: '取消',
    confirmText: '确定',
    content: ''
  };

  function getChild(type) {
    switch (type) {
      case 'confirm':
        return Confirm;

      default:
        return React__default.createElement("div", null);
    }
  }

  var _instace = 0;

  var Dialog =
  /*#__PURE__*/
  function (_Component) {
    _inherits(Dialog, _Component);

    function Dialog(props) {
      var _this;

      _classCallCheck(this, Dialog);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(Dialog).call(this, props));
      _this.istance = _instace++;

      _this.onWrapperClick = function () {
        if (_this.props.hideOnClickWrapper) {
          _this.setState({
            show: false
          }, function () {
            _this.props.onChange(_this.state.show);
          });

          _this.props.onCancelClick();
        }
      };

      _this.state = {
        show: _this.props.visible
      };
      var div = document.createElement('div');
      div.id = "ph-dialog-instance-".concat(_this.istance);
      document.body.appendChild(div);
      _this.domNode = div;
      return _this;
    }

    _createClass(Dialog, [{
      key: "componentWillReceiveProps",
      value: function componentWillReceiveProps(nextProps) {
        this.setState({
          show: nextProps.visible
        });
      }
    }, {
      key: "render",
      value: function render() {
        var _this$props = this.props,
            isPad = _this$props.isPad,
            type = _this$props.type,
            cancelText = _this$props.cancelText,
            confirmText = _this$props.confirmText,
            onConfirmClick = _this$props.onConfirmClick,
            onCancelClick = _this$props.onCancelClick,
            content = _this$props.content,
            children = _this$props.children;
        var show = this.state.show;
        var onWrapperClick = this.onWrapperClick;
        var Child = getChild(type);
        return ReactDOM.createPortal(React__default.createElement(context.Provider, {
          value: {
            cancelText: cancelText,
            confirmText: confirmText,
            onConfirmClick: onConfirmClick,
            onCancelClick: onCancelClick,
            content: content,
            children: children
          }
        }, React__default.createElement("div", {
          className: "ph-dialog-wrapper",
          style: {
            display: show ? 'flex' : 'none'
          },
          onClick: onWrapperClick
        }, React__default.createElement("div", {
          onClick: function onClick(e) {
            return e.stopPropagation();
          },
          className: classnames('ph-dialog', {
            'ph-dialog-pad': isPad
          })
        }, React__default.createElement(Child, null)))), this.domNode);
      }
    }]);

    return Dialog;
  }(React.Component);

  Dialog.defaultProps = {
    type: 'confirm',
    hideOnClickWrapper: true,
    onChange: function onChange() {},
    onConfirmClick: function onConfirmClick() {},
    onCancelClick: function onCancelClick() {},
    cancelText: '取消',
    confirmText: '确定',
    content: ''
  };

  var CheckBox =
  /*#__PURE__*/
  function (_Component) {
    _inherits(CheckBox, _Component);

    function CheckBox() {
      var _this;

      _classCallCheck(this, CheckBox);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(CheckBox).apply(this, arguments));

      _this.onChange = function () {
        var _this$props = _this.props,
            value = _this$props.value,
            onChange = _this$props.onChange; // tslint:disable-next-line

        onChange && onChange(!value);
      };

      return _this;
    }

    _createClass(CheckBox, [{
      key: "render",
      value: function render() {
        var _this$props2 = this.props,
            isPad = _this$props2.isPad,
            label = _this$props2.label,
            children = _this$props2.children,
            className = _this$props2.className,
            value = _this$props2.value;
        var onChange = this.onChange;
        return React__default.createElement("div", {
          className: classnames('ph-checkbox', className, {
            'ph-checkbox-pad': isPad
          }),
          onClick: onChange
        }, React__default.createElement("div", {
          className: classnames('ph-checkbox-img', {
            'ph-checkbox-checked': value
          })
        }), React__default.createElement("div", {
          className: "ph-checkbox-label"
        }, children ? children : label));
      }
    }]);

    return CheckBox;
  }(React.Component);

  CheckBox.defaultProps = {
    className: ''
  };

  var version$1 = '0.18.6';

  exports.AudioBlock = AudioBlock;
  exports.AudioHorn = AudioHorn;
  exports.Avatar = Avatar;
  exports.Checkbox = CheckBox;
  exports.ClickAnime = ClickAnime;
  exports.Dialog = Dialog;
  exports.EmptyRecord = EmptyRecord;
  exports.Imager = Imager;
  exports.Img = Img;
  exports.LongTouch = LongTouch;
  exports.PageFail = PageFail;
  exports.Picture = Picture;
  exports.Subtitle = Subtitle;
  exports.addParams = addParams;
  exports.getImage = getImage;
  exports.loading = index;
  exports.page = PageWrapper;
  exports.pageLoading = PageLoading$1;
  exports.parseParams = parseParams;
  exports.preload = preload;
  exports.storage = index$1;
  exports.toast = Toast$1;
  exports.version = version$1;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
