import parseParams from '../parse-params'

export default function addParams(url: string, params: any) {
  const oldParams = parseParams(url)
  const origin = url.split('?')[0]
  const newParams = { ...oldParams, ...params }
  const temp = Object.keys(newParams).reduce((acc: Array<string>, key) => {
    const value = newParams[key]
    // tslint:disable-next-line
    if (value != null) acc.push(`${key}=${encodeURIComponent(value)}`)
    return acc
  }, [])
  return `${origin}?${temp.join('&')}`
}
