import { PureComponent, ReactElement } from 'react';
import './style.less';
export interface PhButtonProps {
    onClick?: () => void;
    disabled?: boolean;
    type?: string;
    br?: string;
    inline?: boolean;
    className?: string;
    children?: string | ReactElement;
    isPad?: boolean;
}
declare class PhButton extends PureComponent<PhButtonProps> {
    static defaultProps: {
        type: string;
        br: string;
        disabled: boolean;
        inline: boolean;
    };
    onClick: () => void;
    render(): JSX.Element;
}
export default PhButton;
