import './style.less';
import { PureComponent } from 'react';
interface ImgItem {
    src: string;
    height: number;
    width?: number;
    divInner?: boolean;
}
export interface Props {
    list?: Array<ImgItem>;
    img?: ImgItem;
    useDivInner?: boolean;
    pxToRem?: boolean;
    className?: string;
    isPad?: boolean;
    width?: number;
    replace?: boolean;
    onClick?: (e: any, imgItem: ImgItem, index: number) => void;
    onSuccess?: () => void;
    onFailure?: () => void;
}
export default class Picture extends PureComponent<Props, object> {
    static defaultProps: {
        pxToRem: boolean;
    };
    container: HTMLDivElement | null;
    dpr: number;
    componentDidMount(): void;
    componentWillUnmount(): void;
    initImage(): void;
    createImage(listItem: ImgItem, index: number): Promise<{}>;
    render(): JSX.Element;
}
export {};
