import parseParams from '../parse-params';

function addParams(url, params) {
    const oldParams = parseParams(url);
    const origin = url.split('?')[0];
    const newParams = { ...oldParams, ...params };
    const temp = Object.keys(newParams).reduce((acc, key) => {
        const value = newParams[key];
        // tslint:disable-next-line
        if (value != null)
            acc.push(`${key}=${encodeURIComponent(value)}`);
        return acc;
    }, []);
    return `${origin}?${temp.join('&')}`;
}

export default addParams;
