import React, { Component } from 'react';
import { preloadImage } from '../utils';

function preload(imgList) {
    return function preloadHoc(OriginComponent) {
        return class PreloadWrapper extends Component {
            componentWillMount() {
                preloadImage(imgList);
            }
            render() {
                return React.createElement(OriginComponent, Object.assign({}, this.props));
            }
        };
    };
}

export default preload;
