import './style.less';
import React from 'react';
export interface Props {
    url: string;
    isPad?: boolean;
    className?: string;
    onClick?: () => void;
}
declare enum Status {
    PLAY = 0,
    STOP = 1
}
interface State {
    status: Status;
}
export default class AudioHorn extends React.Component<Props, State> {
    audio: HTMLAudioElement | null;
    state: State;
    clickHandler: () => void;
    componentDidMount(): void;
    render(): JSX.Element;
}
export {};
