import { Component, ReactNode } from 'react';
import './style.less';
export interface CheckBoxProps {
    isPad?: boolean;
    onChange?: (checked: boolean) => void;
    label?: string;
    children?: ReactNode;
    className?: string;
    value: boolean;
}
declare class CheckBox extends Component<CheckBoxProps> {
    static defaultProps: {
        className: string;
    };
    onChange: () => void;
    render(): JSX.Element;
}
export default CheckBox;
