import './style.less';
import React, { PureComponent } from 'react';
export interface Props {
    children: any;
    className?: string;
    startTransform?: string;
    endTransform?: string;
    selected?: boolean;
    onClick?: (e: React.MouseEvent) => void;
}
export default class ClickAnime extends PureComponent<Props, {
    touchIn: boolean;
}> {
    static defaultProps: {
        startTransform: string;
        endTransform: string;
        selected: boolean;
    };
    el: HTMLDivElement | null;
    state: {
        touchIn: boolean;
    };
    touchStart: () => void;
    touchEnd: () => void;
    render(): JSX.Element;
}
