import { Component, ReactChildren } from 'react';
export interface ConfirmProps {
    confirmText: string;
    cancelText: string;
    onConfirmClick: () => void;
    onCancelClick: () => void;
    content: string;
    isPad: boolean;
    children: ReactChildren;
}
declare class Confirm extends Component<ConfirmProps> {
    static defaultProps: {
        onConfirmClick: () => void;
        onCancelClick: () => void;
        cancelText: string;
        confirmText: string;
        content: string;
    };
    render(): JSX.Element;
}
export default Confirm;
