import React, { Component } from 'react';
import './index.less';
export interface Props {
    type: string;
    classNames?: string;
    isPad?: boolean;
    visible: boolean;
    hideOnClickWrapper: boolean;
    onChange: Function;
    cancelText: string;
    confirmText: string;
    content: string;
    onConfirmClick: Function;
    onCancelClick: Function;
}
export interface State {
    show: boolean;
}
declare class Dialog extends Component<Props, State> {
    static defaultProps: {
        type: string;
        hideOnClickWrapper: boolean;
        onChange: () => void;
        onConfirmClick: () => void;
        onCancelClick: () => void;
        cancelText: string;
        confirmText: string;
        content: string;
    };
    private istance;
    private domNode;
    constructor(props: Props);
    onWrapperClick: () => void;
    componentWillReceiveProps(nextProps: Props): void;
    render(): React.ReactPortal;
}
export default Dialog;
