import './style.less';
import * as React from 'react';
interface ImgItem {
    [propName: string]: any;
}
export interface Props {
    className?: string;
    widthList?: Array<number>;
    isPad?: boolean;
    imgList: Array<ImgItem>;
    useDivInner?: boolean;
    onClick?: (e: any, imgItem: ImgItem, index: number) => void;
    onSuccess: () => void;
    onFailure: () => void;
    onLongTouch?: () => void;
}
export default class Imager extends React.Component<Props, object> {
    static defaultProps: {
        className: string;
        onSuccess(): void;
        onFailure(): void;
    };
    dpr: number;
    container: HTMLDivElement | null;
    private touchTimer;
    private touchX;
    private touchY;
    componentDidMount(): void;
    initImage(): void;
    createImage(listItem: ImgItem, index: number): Promise<any>;
    onTouchStart: (e: React.TouchEvent<HTMLDivElement>) => void;
    onTouchEnd: (e: React.TouchEvent<HTMLDivElement>) => void;
    render(): JSX.Element;
}
export {};
